#include <math.h>
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/extensions/XShm.h>
#include "xbrush.h"

extern PRGID     *prgid;        /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;       /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

extern XFontStruct *info;    /*  Font Struct */

void Make_brush_scr(BMPPALA *bmp_plm)     /*  ֥饷꡼κ  */
{
    bmp_plm->brush_scr =
        malloc(bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(char));
                                                 /*  ̤Υ֥饷ǻٲ  */
    memset(bmp_plm->brush_scr, 0x00,
                    bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(char));
                                              /*  ֥饷ǻѲ̤ν  */

}

void Make_rgbcolor_scr(BMPPALA *bmp_plm)     /*  RGB顼꡼κ  */
{
    bmp_plm->rgbcolor_scr =
     malloc(bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(unsigned long));
                                                /*  RGB顼꡼  */
    memset(bmp_plm->rgbcolor_scr, 0x00,
           bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(unsigned long));
                                        /*  RGB顼꡼̤ν  */
}

void Init_brush_map(CONSPATS *cons_parts)  /*  initiarize bursh map  */
{
    int    xi, yi;
    unsigned int  i, j;
    int    brush_size, brush_size_h;
    double map_rad;
    double dex;
    short  dey;
    short  odd_num;

    cons_parts->funcval.r_size = (cons_parts->size_vol.size + 1) / 2;
    cons_parts->funcval.g_size =
                   (MAX_BR_SIZE - cons_parts->size_vol.size) / 2 + 1;

    for( j = 0 ; j <= 255 ; j ++ )
    {
        for( i = 0 ; i < 32761 ; i ++ )
        {
            *(cons_parts->funcval.brush_map[j] + i) = 0;
        }
        brush_size = cons_parts->size_vol.size * j / 255;
        brush_size_h = (brush_size + 1) / 2;
        odd_num = brush_size % 2;
                             /*  255Ĵǥ֥饷ޥåפäƤ  */
        for( yi = 0 ; yi <= brush_size_h ; yi ++ )
        {
            for( xi = 0 ; xi <= brush_size_h ; xi ++ )
	    {
	        map_rad = sqrt( xi * xi + yi * yi );
                             /*  ߤΥ֥饷濴εΥФƤ  */

	        dex = (float)map_rad / brush_size_h;
                /*  ߤΰ֤ϡ褹֥饷Ⱦ¤
                                                       ΰ֤ˤ뤫  */

	        dey = Brush_func( cons_parts->funcval.func_no, dex )
                                                  * cons_parts->dens_vol.size;
                                                   /*  Ƥλǻ  */
		if( odd_num )  /*  ֥饷礭2ǳڤʤ  */
                {
                    *(cons_parts->funcval.brush_map[j]
                                      + (90+xi + MAX_BR_SIZE * (90+yi))) = dey;
	            *(cons_parts->funcval.brush_map[j]
                                      + (90+xi + MAX_BR_SIZE * (90-yi))) = dey;
	            *(cons_parts->funcval.brush_map[j]
                                      + (90-xi + MAX_BR_SIZE * (90+yi))) = dey;
	            *(cons_parts->funcval.brush_map[j]
                                      + (90-xi + MAX_BR_SIZE * (90-yi))) = dey;
                }
		else  /*  ֥饷礭2ǳڤ  */
                {
                    *(cons_parts->funcval.brush_map[j]
                                      + (91+xi + MAX_BR_SIZE * (91+yi))) = dey;
	            *(cons_parts->funcval.brush_map[j]
                                      + (91+xi + MAX_BR_SIZE * (90-yi))) = dey;
	            *(cons_parts->funcval.brush_map[j]
                                      + (90-xi + MAX_BR_SIZE * (91+yi))) = dey;
	            *(cons_parts->funcval.brush_map[j]
                                      + (90-xi + MAX_BR_SIZE * (90-yi))) = dey;
                }
	    }
        }
    }
}

/*  褹뿧׻ */
unsigned long    Cal_color(unsigned char den, unsigned long dst_col,
                                  unsigned long src_col)
{
    int      i;
    unsigned short   src[3], dst[3], sh_pix[3];
    unsigned long  c_buf;

    src[0] = (src_col & 0xFF0000) >> 16;
    src[1] = (src_col & 0x00FF00) >> 8;
    src[2] =  src_col & 0x0000FF;
                                             /*  褹뿧Σңǣ  */
    dst[0] = (dst_col & 0xFF0000) >> 16;
    dst[1] = (dst_col & 0x00FF00) >> 8;
    dst[2] =  dst_col & 0x0000FF;
                                             /*  ̤οΣңǣ  */

    for(i = 0; i < 3; i++)
    {
        sh_pix[i] =( ((src[i] * (den + 1)) >> 8)
                     + ((dst[i] * ( 256 - den )) >> 8) ) & 0xFF;
                                      /*  ɽ륫顼ͤ׻  */
    }
    c_buf = sh_pix[0] << 16 | sh_pix[1] << 8 | sh_pix[2];
                         /*  褷Σңǣ¤줾Υ顼ͤʻ  */
    return(c_buf);
}

/*  ɥåȤĥԥͤ׻褹  */
void PutPixel2Image(BMPPALA *bmp_plm, int dx, int dy, long adr_y,
                                    unsigned char den, unsigned long sel_col)
{
  unsigned int r_map, g_map, b_map;
  unsigned char  *sub_dens;
  unsigned char  *os_adres;
  PNT     p;
  unsigned long  drw_col;
  unsigned long  dst_col;

  p.x = dx; p.y = dy;

  sub_dens = bmp_plm->brush_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y;
                                      /*  ֥饷ǻ٤Υɥ쥹Ф  */
  if ( den <= *sub_dens )
    return;
  else
    *sub_dens = den;
  //*(bmp_plm->brush_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y) = den;
      /*  夫֥饷ǻ٤ǻˤϡ夫ǻ٤褹  */

  os_adres = bmp_plm->ibuf_xim->data +
             dx * (bmp_plm->ibuf_xim->bits_per_pixel >> 3) +
             dy * bmp_plm->ibuf_xim->bytes_per_line;
  dst_col = *(os_adres + 2) << 16 | *(os_adres + 1) << 8 | *os_adres;
  //dst_col = XGetPixel(bmp_plm->ibuf_xim, dx, dy);
                            /*  ɥåǼѲ鿧Ф  */
    /*  ޤƤʤʬο,ޤ褹뿧ȤǷ׻ʤƤ
      ʤʤΤ,ibuf_xim 鿧ФƤ  */

  drw_col = Cal_color(den, dst_col, bmp_plm->src_col);
                                /*  褹뿧׻ */

  XPutPixel(bmp_plm->canv_xim, dx, dy, drw_col);  /*  ɥ  */
  XPutPixel(bmp_plm->imag_xim, dx, dy, drw_col);  /*  ̤  */
}

/*  ֥饷礭ʬ  */
void Point_brush(BMPPALA *bmp_plm, int x, int y, CONSPATS *cons_parts,
                                                                 PRGID *prg_id)
{
  int xi, yi, xj, yj, stx, sty, edx, edy;
  int bstx, bedx, bsty, bedy, br_y;
  long adr_y;
  unsigned char den;
  unsigned char msk_dens;   /*  ޥǻ  */
  unsigned short dens_buf;

  int  pres = 255;   /*  ɮ  */
  unsigned long  sel_col;    /*  ԥ  */

    /*  褹ϰϤ imag_rect Ǥʤˤ return   */
  if(x < bmp_plm->drw_rect.c.left || x > bmp_plm->drw_rect.c.right
        || y <  bmp_plm->drw_rect.c.top || y > bmp_plm->drw_rect.c.bottom)
        return;

    bstx = cons_parts->funcval.g_size;
    bedx = cons_parts->funcval.r_size + 90;
    bsty = cons_parts->funcval.g_size;
    bedy = cons_parts->funcval.r_size + 90;

    stx = x - cons_parts->funcval.r_size;  /*  ΰǤ賫ϰ(ɸ)  */
    sty = y - cons_parts->funcval.r_size;  /*  ΰǤ賫ϰ(ɸ)  */
    edx = x + cons_parts->funcval.r_size;  /*  ΰǤ轪λ(ɸ)  */
    edy = y + cons_parts->funcval.r_size;  /*  ΰǤ轪λ(ɸ)  */

  if( stx < 0 )
  {
    bstx += abs( stx );
    stx = 0;
  }
  if( edx >= bmp_plm->wid_size.h )
  {
    bedx -= (edx - bmp_plm->wid_size.h);
    edx = bmp_plm->wid_size.h;
  }
  if( sty < 0 )
  {
    bsty += abs( sty );
    sty = 0;
  }
  if( edy >= bmp_plm->wid_size.v )
  {
    bedy -= (edy - bmp_plm->wid_size.v);
    edy = bmp_plm->wid_size.v;
  }

  adr_y = (sty - bmp_plm->wid_rect.c.top) * bmp_plm->wid_size.h;
                                                /*  ֥饷ǻ٤λȰ  */

  if((prg_id->xb_mode & 0x0010) == 0x0010)
  {                         /*  ֥åȤȤ뤫ɤ  */
    pres = (( bmp_plm->presser -  prg_id->tabpnl.under )
                       * prg_id->tabpnl.mangn) >> 8; /*  ߤɮĴ٤  */
    DEBUG_PRINT(("Point_brush()  presser:%d  pres:%d\n", bmp_plm->presser, pres));
  }
  if(pres <= 0)
    return;

  for( yi = bsty, yj = sty, br_y = MAX_BR_SIZE * bsty;
       yi <= bedy ;
       yi ++, yj ++, adr_y += bmp_plm->wid_size.h, br_y += MAX_BR_SIZE )
  {
    for( xi = bstx, xj = stx; xi <= bedx ; xi ++, xj ++ )
    {
      /*  ֥饷褹뤫ɤĴ٤  */
      den = *(cons_parts->funcval.brush_map[256] + (xi + br_y));
      if( den <= 0 )
          continue;  /*  "֥饷褷ʤ" ϰʹߤνʤ  */

      if(prg_id->xb_mode & 0x0080)  /*  ɮαƶξ  */
      {
        if( pres > 255 )  pres = 255;
                /*  ֥饷ǻ٤Ĵ٤  */
        den = *(cons_parts->funcval.brush_map[pres] + (xi + br_y));
        if ( den <= 0 )
            continue;/*  ֥饷ǻ٤ 0% ξϰʹߤνʤ  */
      }
      else
      {
        den = *(cons_parts->funcval.brush_map[255] + (xi + br_y));
        if ( den <= 0 )
          continue;/*  ֥饷ǻ٤ 0% ξϰʹߤνʤ  */
      }
      if(prg_id->xb_mode & 0x0040)  /*  ɮαƶǻٴξ  */
      {
        if( pres > 255 )  pres = 255;
                /*  ֥饷ǻ٤Ĵ٤  */
        den = (den * (pres + 1)) >> 8;  /*  ɮ,褹ǻ٤׻  */
        if ( den <= 0 )
          continue;/*  ֥饷ǻ٤ 0% ξϰʹߤνʤ  */
      }

      sel_col = cons_parts->slct_col.sel_col;

            /*  ֥饷礭ˤäΰ褫Ϥ߽Ф
                褵ʤ  */
      if ( xj >= bmp_plm->drw_rect.c.left &&
           xj <  bmp_plm->drw_rect.c.right &&
           yj >= bmp_plm->drw_rect.c.top &&
           yj <  bmp_plm->drw_rect.c.bottom)
      {
        if( (prg_id->mask_mode & 0x00C0) == 0x0000 )
                                   /*  ̾⡼ɡפξ  */
          PutPixel2Image(bmp_plm, xj, yj, adr_y, den, sel_col);
                             /*  ɥåȤĥԥͤ׻褹  */

        else if( (prg_id->mask_mode & 0x00C0) == 0x0040 )
                                  /*  ֥ޥȿ⡼ɡפξ  */
        {
          msk_dens = *(bmp_plm->mask_scr +
                                     (xj - bmp_plm->wid_rect.c.left) + adr_y);
                                                 /*  ޥǻ٤Ф  */
          if(msk_dens == 0x00)
            continue;  /*  ޥǻ٤ 0 ξ褷ʤ  */
          else if(msk_dens == 0xFF)
                    ;
          else
          {
            dens_buf = den;
            den = (dens_buf * msk_dens) >> 8;
                                       /*  ޥ褹ǻ٤׻  */
          }
          PutPixel2Image(bmp_plm, xj, yj, adr_y, den, sel_col);
        }

        else if( (prg_id->mask_mode & 0x00C0) == 0x0080 )
                                 /*  ֥ޥ⡼ɡפξ  */
          Put_Maskdepth(bmp_plm, xj, yj, adr_y, den);
                               /*  ɥåȤĥޥ褹  */

        else if( (prg_id->mask_mode & 0x00C0) == 0x00C0 )
                                  /*  ֥ޥõ⡼ɡפξ  */
          Els_Maskdepth(bmp_plm, xj, yj, adr_y, den);
                                /*  ɥåȤĥޥä  */
      }
    }
  }

  XShmPutImage( bmp_plm->disp, bmp_plm->canv_gid, bmp_plm->canv_gc,
                               bmp_plm->canv_xim,
                               stx, sty, stx, sty, edx-stx, edy-sty, False );
                                                    /*  ɥɽ  */
}

/*  ɥåλ  */
void Drw_brush(BMPPALA *bmp_plm, PNT sp, PNT ep,
	                                  CONSPATS *cons_parts, PRGID *prg_id)
{
    int     situ_x, situ_y, i;
    unsigned int    dx, dy, cont, da, db, dc, b_size_h;
    PNT   sp1, sp2, ep1, ep2, drw_s;

    dx = abs(sp.x - ep.x);
    dy = abs(sp.y - ep.y);
    dc = sqrt( dx * dx + dy * dy );
    if(dc <= 0)
      return;

    b_size_h = (bmp_plm->b_size + 1) / 2;

    da = (b_size_h * dx) / dc;
    db = (b_size_h * dy) / dc;

    if ( sp.x > ep.x )
    {
        situ_x = -1;
        sp1.y = sp.y + da;
        ep1.y = ep.y + da;
        sp2.y = sp.y - da;
        ep2.y = ep.y - da;
    }
    else
    {
        situ_x = 1;
        sp1.y = sp.y - da;
        ep1.y = ep.y - da;
        sp2.y = sp.y + da;
        ep2.y = ep.y + da;
    }
    if ( sp.y > ep.y )
    {
        situ_y = -1;
        sp1.x = sp.x - db;
        ep1.x = ep.x - db;
        sp2.x = sp.x + db;
        ep2.x = ep.x + db;
    }
    else
    {
        situ_y = 1;
        sp1.x = sp.x + db;
        ep1.x = ep.x + db;
        sp2.x = sp.x - db;
        ep2.x = ep.x - db;
    }

    drw_s.x = sp.x;
    drw_s.y = sp.y;

    for( i = 0 ; i < 32761 ; i ++ )
    {
        *(cons_parts->funcval.brush_map[256] + i) = 0;
    }

    Drw_line_reng(sp, sp1, cons_parts);  /*  ɥåϰϤλ  */

    if( dx > dy )
    {
        cont = dx >> 1;
        if( sp.x < ep.x )
        {
            for( drw_s.x = sp.x ; drw_s.x <= ep.x ; drw_s.x ++ )
            {
                Point_brush(bmp_plm, drw_s.x, drw_s.y, cons_parts, prg_id);
                cont += dy;
                if ( cont >= dx )
                {
                    drw_s.y += situ_y;
                    cont -= dx;
                }
            }
        }
        else
        {
            for( drw_s.x = sp.x ; drw_s.x >= ep.x ; drw_s.x -- )
            {
                Point_brush(bmp_plm, drw_s.x, drw_s.y, cons_parts, prg_id);
                cont += dy;
                if ( cont >= dx )
                {
                    drw_s.y += situ_y;
                    cont -= dx;
                }
            }
        }
    }
    else
    {
        cont = dy >> 1;
        if( sp.y < ep.y )
        {
            for( drw_s.y = sp.y ; drw_s.y <= ep.y ; drw_s.y ++ )
            {
                Point_brush(bmp_plm, drw_s.x, drw_s.y, cons_parts, prg_id);
                cont += dx;
                if ( cont >= dy )
          	{
                  drw_s.x += situ_x;
                  cont -= dy;
                }
            }
        }
        else
        {
            for( drw_s.y = sp.y ; drw_s.y >= ep.y ; drw_s.y -- )
            {
                Point_brush(bmp_plm, drw_s.x, drw_s.y, cons_parts, prg_id);
                cont += dx;
                if ( cont >= dy )
                {
                    drw_s.x += situ_x;
                    cont -= dy;
                }
            }
        }
    }

    for( i = 0 ; i < 32761 ; i ++ )
    {
        *(cons_parts->funcval.brush_map[256] + i) = 255;
    }

}

/*  ɥåϰϤλ  */
void Drw_line_reng(PNT sp, PNT ep, CONSPATS *cons_parts)
{
    int     x, y, ex, ey, situ_x, situ_y, dr_pt1, dr_pt2;
    int     dx, dy, cont, y_line;

    dx = abs(sp.x - ep.x);
    dy = abs(sp.y - ep.y);

    if ( sp.x > ep.x )
        situ_x = -1;
    else
        situ_x = 1;
    if ( sp.y > ep.y )
    {
        situ_y = -1;
        y_line = -(MAX_BR_SIZE);
    }
    else
    {
        situ_y = 1;
        y_line = MAX_BR_SIZE;
    }

    x = 0;
    y = 0;
    ex = ep.x - sp.x;
    ey = ep.y - sp.y;
    dr_pt1 = dr_pt2 = (MAX_BR_SIZE + 1) * (MAX_BR_SIZE / 2);
                                  /*  ֥饷ޥåפ濴  */

    if( dx > dy )
    {
        cont = dx >> 1;
        if( sp.x < ep.x )
        {
            for( x = 0 ; x <= ex; x ++ )
            {
                *(cons_parts->funcval.brush_map[256] + dr_pt1) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt2) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt1 - 1) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt2 - 1) = 255;
                cont += dy;
                if ( cont >= dx )
                {
                    y += situ_y;
                    cont -= dx;
                    dr_pt1 += y_line;
                    dr_pt2 -= y_line;
                }
                dr_pt1 += situ_x;
                dr_pt2 -= situ_x;
            }
        }
        else
        {
            for( x = 0 ; x >= ex ; x -- )
            {
                *(cons_parts->funcval.brush_map[256] + dr_pt1) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt2) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt1 + 1) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt2 + 1) = 255;
                cont += dy;
                if ( cont >= dx )
                {
                    y += situ_y;
                    cont -= dx;
                    dr_pt1 += y_line;
                    dr_pt2 -= y_line;
                }
                dr_pt1 += situ_x;
                dr_pt2 -= situ_x;
            }
        }
    }
    else
    {
        cont = dy >> 1;
        if( sp.y < ep.y )
        {
            for( y = 0 ; y <= ey ; y ++ )
            {
                *(cons_parts->funcval.brush_map[256] + dr_pt1) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt2) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt1 - MAX_BR_SIZE) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt2 - MAX_BR_SIZE) = 255;
                cont += dx;
                if ( cont >= dy )
          	{
                    x += situ_x;
                    cont -= dy;
                    dr_pt1 += situ_x;
                    dr_pt2 -= situ_x;
                }
                dr_pt1 += y_line;
                dr_pt2 -= y_line;
            }
        }
        else
        {
            for( y = 0 ; y >= ey ; y -- )
            {
                *(cons_parts->funcval.brush_map[256] + dr_pt1) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt2) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt1 + MAX_BR_SIZE) = 255;
                *(cons_parts->funcval.brush_map[256] + dr_pt2 + MAX_BR_SIZE) = 255;
                cont += dx;
                if ( cont >= dy )
                {
                    x += situ_x;
                    cont -= dy;
                    dr_pt1 += situ_x;
                    dr_pt2 -= situ_x;
                }
                dr_pt1 += y_line;
                dr_pt2 -= y_line;
            }
        }
    }
}
