/*
	file.c		xbrush

	$B%U%!%$%kA`:n(B
*/

#include <stdlib.h>
#include <stdio.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xlib.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/extensions/XShm.h>
#include "xbrush.h"

#define LENGTH   100
#define THICKNESS 16
#define SHOWN      1
#define END      100

extern PRGID     *prgid;        /*  $B3F<o$N#I#D(B  */
extern BMPPALA   *bmpplm;       /*  $B%S%C%H%^%C%W(B  */
extern CONSPATS  *consparts;    /*  $B%3%s%=!<%k%Q!<%D(B  */

extern XFontStruct *info;    /*  Font Struct */
static int format_no = 0;
static float qual_el = 0.75;
extern String filename;

/*  BMP $B$H(B Ximage $B$N:F:n@.(B  */
int Recreate_BmpXim(Display *dsp, Visual *vis, BMPPALA *bmp_plm,
                    int width, int height)
{
  bmp_plm->org_bmp.bounds.c.left   = 0;
  bmp_plm->org_bmp.bounds.c.right  = width;
  bmp_plm->org_bmp.bounds.c.top    = 0;
  bmp_plm->org_bmp.bounds.c.bottom = height;

   /*  bmp $B$N=i4|2=(B  */
  if(Creat_bmp(&bmp_plm->org_bmp, bmp_plm->org_bmp.bounds,
                  bmp_plm->org_bmp.planes, (vis->bits_per_rgb * 3))     < 0)
                                               /*    $B%S%C%H%^%C%W$r:n@.(B    */
    return(-1);

  /*  org_xim $B$N(B XImage $B4D6-$r:n$k(B  */
  bmp_plm->org_xim =
                    CreateXImage( dsp, width, height );  /*  XImage$B$N:n@.(B  */

  return(1);
}

/*  $B2hA|$rFI$_9~$`$?$a$N2<=`Hw(B  */
int Recreate_Imagedata(BMPPALA *bmp_plm, Visual *vis, int width, int height)
{
  DEBUG_PRINT(("Recreate_Imagedata()\n"));
  Free_bitmap(bmp_plm->org_xim);  /*  $B862hA|%S%C%H%^%C%W$N%a%b%j$r3+J|(B  */

  bmp_plm->org_size.h = width;
  bmp_plm->org_size.v = height;

  if( Recreate_BmpXim(bmp_plm->disp, vis, bmp_plm,
                                      width, height)  <  0 )
                                                /*  BMP $B$H(B Ximage $B$N:F:n@.(B  */
    Exit_prg(prgid, bmpplm, consparts);/*  $B%a%b%j3NJ]$G$-$J$+$C$?$i=*N;(B  */

  Clr_xim(bmp_plm->canv_xim);    /*  XImage $B$N%/%j%"(B  */
  Free_mask_mat(bmp_plm);       /*  $B%^%9%/2hLLMQ%a%b%j>C5n(B  */

  return(0);
}

void Loadfile(String filename, BMPPALA *bmp_plm, PRGID *prg_id)
                                                        /*  $B%U%!%$%k%m!<%I(B  */
{
  Display  *dsp;
  Visual   *vis;
  Window   win;
  static FILE  *fp;
  int  scr;
  SIZE     size;

  DEBUG_PRINT(("Loadfile()\n"));

  dsp     = XtDisplay( prg_id->canv_wid );
  scr     = DefaultScreen( bmp_plm->disp );    /*  $B%G%U%)%k%H%9%/%j!<%sHV9f(B  */
  vis     = DefaultVisual( bmp_plm->disp, scr );  /*  $B%G%U%)%k%H%S%8%e%"%k(B  */

  if( (fp = fopen( filename, "rb" )) == NULL )
  {
    fprintf( stderr, "Cannot Open %s \n", filename );
    return;
  }

  for(;;)
  {
    if( LoadXbr(bmp_plm->disp, vis, fp, bmp_plm->org_xim, bmp_plm, &size, 0) )
    {
      Recreate_Imagedata(bmp_plm, vis, size.h, size.v);
                                            /*  $B2hA|$rFI$_9~$`$?$a$N2<=`Hw(B  */

      fseek( fp, 0, 0 );
      LoadXbr(bmp_plm->disp, vis, fp, bmp_plm->org_xim, bmp_plm, &size, 1);
                                            /*  XBR $B%U%!%$%k$NFI$_9~$_(B  */
      fclose( fp );
      break;
    }
    fseek( fp, 0, 0 );
    if( LoadJpeg(bmp_plm->disp, vis, fp, bmp_plm->org_xim, &size, 0) )
    {
      Recreate_Imagedata(bmp_plm, vis, size.h, size.v);
                                            /*  $B2hA|$rFI$_9~$`$?$a$N2<=`Hw(B  */

      fseek( fp, 0, 0 );
      LoadJpeg(bmp_plm->disp, vis, fp, bmp_plm->org_xim, &size, 1);
                                            /*  Jpeg $B%U%!%$%k$NFI$_9~$_(B  */
      fclose( fp );
      Make_mask_mat(bmp_plm);       /*  $B%^%9%/2hLLMQ%a%b%j$r:n@.(B  */
      break;
    }
    fseek( fp, 0, 0 );
    if( LoadPng(bmp_plm->disp, vis, fp, bmp_plm->org_xim, &size, 0) )
    {
      Recreate_Imagedata(bmp_plm, vis, size.h, size.v);
                                            /*  $B2hA|$rFI$_9~$`$?$a$N2<=`Hw(B  */

      fseek( fp, 0, 0 );
      LoadPng(bmp_plm->disp, vis, fp, bmp_plm->org_xim, &size, 1);
                                            /*  PNG $B%U%!%$%k$NFI$_9~$_(B  */
      fclose( fp );
      Make_mask_mat(bmp_plm);       /*  $B%^%9%/2hLLMQ%a%b%j$r:n@.(B  */
      break;
    }
    fseek( fp, 0, 0 );
    if( LoadXwd(bmp_plm->disp, vis, fp, bmp_plm->org_xim, &size, 0) )
    {
      Recreate_Imagedata(bmp_plm, vis, size.h, size.v);
                                            /*  $B2hA|$rFI$_9~$`$?$a$N2<=`Hw(B  */

      fseek( fp, 0, 0 );
      LoadXwd(bmp_plm->disp, vis, fp, bmp_plm->org_xim, &size, 1);
                                            /*  XWD $B%U%!%$%k$NFI$_9~$_(B  */
      fclose( fp );
      Make_mask_mat(bmp_plm);       /*  $B%^%9%/2hLLMQ%a%b%j$r:n@.(B  */
      break;
    }
    fseek( fp, 0, 0 );
    fprintf( stderr, "Cannot Open file format %s \n", filename );
    fclose( fp );
    return;
  }
  DEBUG_PRINT(("Loadfile(3)\n"));

  Copy_org2orgbuf(bmpplm);    /*  $B862h%P%C%U%!$K5-21(B  */
  Copy_undo_bmp(bmpplm);    /*  $B%"%s%I%%%P%C%U%!$K5-21(B  */

  prg_id->xb_mode &= 0xFFF7;  /*  $BIA2h%b!<%I$r%j%;%C%H(B  */
  prg_id->mask_mode &= 0xFFFE;  /*  $B%^%9%/%U%i%0$r%j%;%C%H(B  */

  bmp_plm->zoom = 1;

  Zoom_point(bmp_plm); /*  $BI=<($9$kJ,$N<B:]$N2hA|$NNN0h$r7W;;$9$k(B  */
  Zoom(bmp_plm);  /*  $B3HBg=L>.I=<((B  */

  Rest_mask(&bmp_plm->org_bmp.bounds, &bmp_plm->zoom_rect,
                          bmp_plm->mask_mat,
                         &bmp_plm->wid_rect,  &bmp_plm->drw_rect,
                                            bmpplm->mask_scr, bmpplm->zoom);
                                    /*  $B%^%9%/2hLL$+$i%^%9%/%9%/%j!<%s$X(B  */

  win = XtWindow( prg_id->canv_wid );

  Redraw_canv(prg_id, bmp_plm);   /*  $BIA2h%&%#%s%I%&$N:FI=<((B  */

  Set_sclbar(prg_id->rbar_pid, prg_id->bbar_pid,
		 bmp_plm->zoom_rect, bmp_plm->org_bmp.bounds);
                                  /*  $B%&%#%s%I%&%9%/%m!<%k%P!<$N@_Dj(B  */
  DEBUG_PRINT(("Loadfile(end)\n"));
}

void Loadfile_evn(Widget w, caddr_t client_data, caddr_t call_data)
                                                       /*  Load file event  */
{
  XtVaGetValues( prgid->filesel.fileview, XtNstring, &filename, NULL );
           /*  $B%U%!%$%k%;%l%/%?$G;XDj$7$?%U%!%$%k%M!<%`$r<h$j=P$7$F$$$k(B  */

  XDefineCursor( XtDisplay(prgid->pwid), XtWindow(prgid->pwid),
                       XCreateFontCursor(XtDisplay(prgid->pwid), XC_watch) );
                                              /*  $B%+!<%=%k$r;~7W$KJQ$($k(B  */
  Loadfile(filename, bmpplm, prgid);   /*  $B%U%!%$%k%m!<%I(B  */
  XUndefineCursor( XtDisplay(prgid->pwid), XtWindow(prgid->pwid) );
                                              /*  $B%+!<%=%k$r85$KLa$9(B  */
}

void Savefile(Widget w, caddr_t client_data, caddr_t call_data)
                                                           /*  Save file  */
{
  Display  *dsp;
  Visual   *vis;
  int     scr, width, height;

  width  = bmpplm->org_bmp.bounds.c.right - bmpplm->org_bmp.bounds.c.left;
  height = bmpplm->org_bmp.bounds.c.bottom - bmpplm->org_bmp.bounds.c.top;

  dsp     = XtDisplay( prgid->canv_wid );
  scr     = DefaultScreen( bmpplm->disp );    /*  $B%G%U%)%k%H%9%/%j!<%sHV9f(B  */
  vis     = DefaultVisual( bmpplm->disp, scr );  /*  $B%G%U%)%k%H%S%8%e%"%k(B  */

  XtVaGetValues( prgid->filesel.fileview, XtNstring, &filename, NULL );

  XDefineCursor( XtDisplay(prgid->pwid), XtWindow(prgid->pwid),
                       XCreateFontCursor(XtDisplay(prgid->pwid), XC_watch) );
                                              /*  $B%+!<%=%k$r;~7W$KJQ$($k(B  */
  if( format_no == 0 )
    SaveXbr( bmpplm->disp, vis, filename,  bmpplm->org_xim, bmpplm, 0, 0, 0,
	    width, height );
  if( format_no == 1 )
    SaveJpeg( bmpplm->disp, vis, filename,  bmpplm->org_xim, 0, 0, qual_el,
	    width, height );
  if( format_no == 2 )
    SavePng( bmpplm->disp, vis, filename,  bmpplm->org_xim, 0, 0, qual_el,
	    width, height );
  if( format_no == 3 )
    SaveXwd( bmpplm->disp, vis, filename,  bmpplm->org_xim, 0, 0, 0,
	    width, height );

  XUndefineCursor( XtDisplay(prgid->pwid), XtWindow(prgid->pwid) );
                                              /*  $B%+!<%=%k$r85$KLa$9(B  */

  if( XtIsRealized(prgid->filesel.form_sel_box) )
    XtUnmanageChild( prgid->filesel.form_sel_box );
                   /*  $B%U%!%$%k%U%)!<%^%C%HA*Br%Q%M%k$N%]%C%W%@%&%s(B  */
}

void Set_format_list(Widget flist)
                          /*  Set save_file_image format to List Widget */
{
  static char *f_list[4] = {"XBR", "Jpeg", "PNG", "XWD"};

  XawListChange( flist, f_list, 4, 0, False );
}

void Set_qual_el()  /* Express image quality */
{
  Arg args[1];
  char str[20];
  int level;

  if( format_no == 0 )
  {
    sprintf( str, " " );
  }
  if( format_no == 1 )
  {
    level = qual_el * 100;
    sprintf( str, "quality = %3d", level );
  }
  if( format_no == 2 )
  {
    level = 1 + qual_el * 9;
    if( level > 9 )
      level = 9;
    sprintf( str, "compress= %d.0", level );
  }
  if( format_no == 3 )
  {
    sprintf( str, " " );
  }
  XtSetArg( args[0], XtNlabel, str );
  XtSetValues( prgid->filesel.quality, args, 1 );
}

void Sel_format(Widget w, caddr_t client_data, caddr_t call_data)
                                                  /* Select image format */
{
  Arg args[1];
  Boolean  sens_flg;
  XawListReturnStruct  *f_ret;

  f_ret = (XawListReturnStruct *)call_data;

  format_no = f_ret->list_index;
  /*   format_no:  XBR = 0, Jpeg = 1, PNG = 2   */

  if( format_no == 1 || format_no == 2 )
    sens_flg = True;
  else
    sens_flg = False;
  XtSetArg( args[0], XtNsensitive, sens_flg );
  XtSetValues( prgid->filesel.qual_scr, args, 1 );
  XtSetValues( prgid->filesel.quality, args, 1 );
  Set_qual_el();
}

void Quality_Jump(Widget w, caddr_t client_data, caddr_t call_data)
                                                     /* Set image quality */
{
  float percent = *(float*)call_data;

  if(percent > (float)END/LENGTH)
      percent = (float)END/LENGTH;
  qual_el = percent;
  Set_qual_el();
}

void Popup_fileformat(Widget w, caddr_t client_data, caddr_t call_data)
                                               /*  Popup Fileformat Widget  */
{
  int horiz, vert;
  RECT rect;
  Arg  args[2];

  Wget_wrk(prgid->pwid, &rect);  /*  $B%&%#%s%I%&I=<(NN0h$N0LCV(B  */

  horiz = ((rect.c.right - rect.c.left) - 110) / 2;
  vert = ((rect.c.bottom - rect.c.top) - 200) / 2;
  XtSetArg( args[0], XtNhorizDistance, (XtArgVal)horiz);
  XtSetArg( args[1], XtNvertDistance, (XtArgVal)vert);

  XtSetValues( prgid->filesel.form_sel_box, args, XtNumber(args) );
                                              /*  $B%\%C%/%9%&%#%8%C%H$X@_Dj(B  */

  XawListHighlight( prgid->filesel.format_list, format_no );
  //XtUnmanageChild( prgid->cons_wid );
  XtManageChild( prgid->filesel.form_sel_box );
}

void Popdown_fileformat(Widget w, caddr_t client_data, caddr_t call_data)
                                              /* Popdown Fileformat Widget */
{
  if( XtIsRealized(prgid->filesel.form_sel_box) )
    XtUnmanageChild( prgid->filesel.form_sel_box );
                   /*  $B%U%!%$%k%U%)!<%^%C%HA*Br%Q%M%k$N%]%C%W%@%&%s(B  */
  //XtManageChild( prgid->cons_wid );
}

Widget Format_popup(Widget parent, PRGID *prg_id)  /*  Select File format */
{
  static Widget  form_sel_box, dialoglabel, save_ok, cancel;

  static  char  defaultTranslations[] =
    "<Btn1Down> : StartScroll(Continuos)MoveThumb()NotifyThumb() \n\
     <Btn1Motion> : MoveThumb()NotifyThumb()";
  XtTranslations trans_table;

  static  XtCallbackRec  callback[] =
  { {(XtCallbackProc)Quality_Jump, NULL},
    {NULL, NULL},
  };

  form_sel_box = XtVaCreateWidget("form_sel_box", boxWidgetClass,
                                     parent,
			             XtNborderWidth, 4,
				     XtNwidth,       110,
				     XtNheight,      210,
 			             XtNbackground,  GRAY,
				     NULL);

  dialoglabel  = XtVaCreateManagedWidget("dialoglabel", labelWidgetClass,
					 form_sel_box,
					 XtNborderWidth,   0,
					 XtNwidth,       100,
					 XtNheight,       20,
					 XtNlabel, (XtArgVal)"Save Dialog",
					 XtNresize,      None,
					 XtNfont,        info,
 			                 XtNbackground,  GRAY,
					 NULL);

  prg_id->filesel.format_list = XtVaCreateManagedWidget("format_list",
                                        listWidgetClass,
					form_sel_box, 
					XtNborderWidth, 1,
					XtNdefaultColumns, 1,
					XtNforceColumns,   True,
					XtNinternalWidth,  30,
					XtNwidth,       100,
					XtNheight,      74, 
					XtNfont,        info,
 			                XtNbackground,  LGRAY,
					NULL);

  prg_id->filesel.quality = XtVaCreateManagedWidget("quality",
                                     labelWidgetClass,
                                     form_sel_box,
				     XtNwidth,       100,
				     XtNheight,       20,
				     XtNresize,      None,
				     XtNsensitive,  False,
				     XtNlabel,     (XtArgVal)"    ",
				     XtNfont,        info,
 			             XtNbackground,  LGRAY,
				     NULL);

  prg_id->filesel.qual_scr = XtVaCreateManagedWidget("qual_scr",
                                   scrollbarWidgetClass,
				   form_sel_box,
				   XtNorientation,(XtArgVal)XtorientHorizontal,
				   XtNlength,     (XtArgVal)LENGTH,
				   XtNthickness,  (XtArgVal)THICKNESS,
				   XtNjumpProc,   (XtArgVal)callback,
				   XtNsensitive,  (XtArgVal)False,
                                   XtNwidth,    (XtArgVal)LENGTH,
                                   XtNheight,    (XtArgVal)THICKNESS,
 			           XtNbackground,  DGRAY,
				   NULL);

  save_ok  = XtVaCreateManagedWidget("Ok", commandWidgetClass,
                                  form_sel_box,
				  XtNwidth,       100,
				  XtNheight,       20,
				  XtNfont,        info,
 			          XtNbackground,  LGRAY,
				  NULL);

  cancel  = XtVaCreateManagedWidget("Cancel", commandWidgetClass,
                                    form_sel_box,
				    XtNwidth,       100,
				    XtNheight,       20,
				    XtNfont,        info,
 			            XtNbackground,  LGRAY,
				    NULL);

  Set_format_list(prg_id->filesel.format_list);
  XtAddCallback(prg_id->filesel.format_list, XtNcallback,
                                           (XtCallbackProc)Sel_format, NULL);
  XtAddCallback(save_ok, XtNcallback, (XtCallbackProc)Savefile, NULL);
  XtAddCallback(cancel, XtNcallback, (XtCallbackProc)Popdown_fileformat, NULL);
  XawScrollbarSetThumb( prg_id->filesel.qual_scr, qual_el, 0.0 );

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(prg_id->filesel.qual_scr, trans_table);

  return( form_sel_box );
}
