/*
	filesel.c		xbrush

	$B%U%!%$%kA*Br(B
*/

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>
#include "xbrush.h"

extern PRGID     *prgid;        /*  $B3F<o$N#I#D(B  */
extern BMPPALA   *bmpplm;       /*  $B%S%C%H%^%C%W(B  */
extern CONSPATS  *consparts;    /*  $B%3%s%=!<%k%Q!<%D(B  */

extern XFontStruct *info;    /*  Font Struct */
static String *listfile;    /*  file list in directory  */
static int dir_cnt;        /*  number of files in directory */
static Widget   file_box, paned, vport, load, save, cancel;

static char defaultTranslations[] = "<Key>Return: no-op()";

void Clear_list()  /* Clear file list in directory  */
{
  int i;

  for( i = 0; i < dir_cnt ; i++ )
    XtFree( (String)listfile[i] );
  XtFree( (String)listfile );
}

int comp( x, y )
char **x;
char **y;
{
  return( strcmp( *x, *y ));
}

void Set_string_text( Widget w, char *name )  /* Set string Widget label */
{
  Arg arg[1];

  XtSetArg( arg[0], XtNstring, name );
  XtSetValues( w, arg, 1 );
}

void Inputlist() /* set filename to buffer */
{
  Arg  args[2];

  DIR  *dir;
  char dir_buf[256];
  struct dirent *dirfile;
  int cnt;

  cnt = 0;

  dir = opendir(".");
  while((dirfile = readdir(dir)) != NULL)
    cnt ++;
  closedir(dir);

  listfile = (String *) XtMalloc( sizeof( String * ) * cnt + 1 );
  cnt = 0;
  dir = opendir(".");
  while((dirfile = readdir(dir)) != NULL)
  {
    listfile[cnt] = XtNewString(dirfile->d_name);
    cnt ++;
  }
  listfile[cnt] = NULL;

  getcwd( dir_buf, sizeof( dir_buf ));
  Set_string_text( prgid->filesel.dirview, dir_buf );

  closedir(dir);
  dir_cnt = cnt;
  qsort( listfile, dir_cnt, sizeof( String ), comp);

  XawListChange( prgid->filesel.filelist, listfile, 0, 0, True );

  XtSetArg( args[0], XtNwidth, (XtArgVal)300);
  XtSetArg( args[1], XtNheight, (XtArgVal)800);
  XtSetValues( prgid->filesel.filelist, args, XtNumber(args) );
  /*  $B2?8N$+$3$3$G%j%9%H%&%#%8%C%H$NBg$-$5$r@_Dj$7$J$$$H!"(B
      $B$9$Y$F$N9`L\$,I=<($5$l$J$+$C$?$j!"9`L\$,A4$FI=<($7$F$"$k$N$K$b(B
      $B78$o$i$:!"%9%/%m!<%k%P!<$,=P$?$^$^$K$J$C$?$j$9$k(B  */

  return;
}

void Select(Widget w, caddr_t client_data, caddr_t call_data) /* select file */
{
  char *f_name;
  struct stat sbuf;
  XawListReturnStruct  *f_ret;

  f_ret = (XawListReturnStruct *)call_data;

  f_name = f_ret->string;
  Set_string_text( prgid->filesel.fileview, f_name );

  stat( f_name, &sbuf );
  if ( S_ISDIR( sbuf.st_mode ) )
  {
    chdir( f_name );
    Clear_list();
    Inputlist();
  }

}

void Popup_filesel(Widget w, caddr_t client_data, caddr_t call_data)
                                     /*  $B%U%!%$%k%;%l%/%?$N%]%C%W%"%C%W(B  */
{
  int horiz, vert;
  RECT rect;
  Arg  args[2];

  Wget_wrk(prgid->pwid, &rect);  /*  $B%&%#%s%I%&I=<(NN0h$N0LCV(B  */

  horiz = ((rect.c.right - rect.c.left) - 310) / 2;
  vert = ((rect.c.bottom - rect.c.top) - 490) / 2;
  XtSetArg( args[0], XtNhorizDistance, (XtArgVal)horiz);
  XtSetArg( args[1], XtNvertDistance, (XtArgVal)vert);

  XtSetValues( prgid->filesel.box, args, XtNumber(args) );
                                              /*  $B%\%C%/%9%&%#%8%C%H$X@_Dj(B  */
  Inputlist();
  if( XtIsRealized(prgid->main_mid) )
    XtUnmanageChild( prgid->main_mid );  /*  $B%&%#%8%C%H$rJD$8$k(B  */
  XtManageChild( prgid->filesel.box );  /*  $B%&%#%8%C%H$NI=<((B  */
}

void Popdown_filesel(Widget w, caddr_t client_data, caddr_t call_data)
                                                /* Popdown Filesel Widget */
{
  if( XtIsRealized(prgid->filesel.box) )
    XtUnmanageChild( prgid->filesel.box );
                                  /*  $B%U%!%$%k%;%l%/%?%\%C%/%9$rJD$8$k(B  */
  Popdown_fileformat( w, (caddr_t)prgid, NULL );
}

Widget Filemenu(PRGID *prg_id)  /*  $B%U%!%$%k%;%l%/%H$N%a%K%e!<:n@.(B  */
{
  XtTranslations trans_table;

  file_box = XtVaCreateWidget("box", formWidgetClass,
                            prg_id->pwid,
			    XtNborderWidth, 4,
			    XtNwidth, 310,
			    XtNheight, 490,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNleft,   XtChainLeft,
			    XtNright,  XtChainLeft,
 			    XtNbackground,  GRAY,
			    NULL);

  prg_id->filesel.dirview = XtVaCreateManagedWidget("dirview",
                                     asciiTextWidgetClass,
                                     file_box,
				     XtNlength, 128,
				     XtNwidth,  300,
			             XtNhorizDistance, 5,
			             XtNvertDistance,  5,
				     XtNfont,   info,
 			             XtNbackground,  LGRAY,
				     NULL);

  prg_id->filesel.fileview = XtVaCreateManagedWidget("fileview",
                                      asciiTextWidgetClass,
                                      file_box,
				      XtNeditType, XawtextEdit,
				      XtNlength,   128,
				      XtNwidth,    300,
			              XtNhorizDistance, 5,
			              XtNvertDistance,  30,
				      XtNfont,   info,
 			              XtNbackground,  LGRAY,
				      NULL);

  paned = XtVaCreateManagedWidget("paned", panedWidgetClass,
                                   file_box, 
				   XtNborderWidth, 1,
			           XtNhorizDistance, 5,
			           XtNvertDistance,  56,
				   XtNwidth,       300,
				   XtNheight,      400, 
 			           XtNbackground,  LGRAY,
				   NULL);

  vport  = XtVaCreateManagedWidget("vport", viewportWidgetClass,
				   paned,
				   XtNallowHoriz, TRUE,
				   XtNallowVert, TRUE,
				   XtNuseBottom, TRUE,
				   XtNuseRight, TRUE,
				   XtNfont,   info,
 			           XtNbackground,  LGRAY,
				   NULL);

  prg_id->filesel.filelist = XtVaCreateManagedWidget("fileList", listWidgetClass,
				       vport,
				       XtNfont,   info,
   			               XtNbackground,  LGRAY,
				       NULL);

  load  = XtVaCreateManagedWidget("Load", commandWidgetClass,
                                  file_box,
			          XtNlabel, (XtArgVal)"Load",
			          XtNhorizDistance, 10,
			          XtNvertDistance,  464,
				  XtNfont,   info,
 				  XtNbackground,  LGRAY,
				  NULL);

  save  = XtVaCreateManagedWidget("Save", commandWidgetClass,
                                  file_box,
			          XtNlabel, (XtArgVal)"Save",
			          XtNhorizDistance, 60,
			          XtNvertDistance,  464,
				  XtNfont,   info,
 				  XtNbackground,  LGRAY,
				  NULL);

  cancel  = XtVaCreateManagedWidget("Cancel", commandWidgetClass,
                                  file_box,
 			          XtNlabel, (XtArgVal)"Cancel",
			          XtNhorizDistance, 110,
			          XtNvertDistance,  464,
			          XtNfont,   info,
 			          XtNbackground,  LGRAY,
			          NULL);

  prg_id->filesel.form_sel_box = Format_popup( prg_id->pwid, prg_id );

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(prg_id->filesel.fileview, trans_table);

  XtAddCallback(prg_id->filesel.filelist, XtNcallback,
                                           (XtCallbackProc)Select, NULL);
  XtAddCallback(load, XtNcallback, (XtCallbackProc)Loadfile_evn, NULL);
  XtAddCallback(save, XtNcallback, (XtCallbackProc)Popup_fileformat, NULL);
  XtAddCallback(cancel, XtNcallback, (XtCallbackProc)Popdown_filesel, NULL);

  return( file_box );
}
