/*
	main.c		xbrush

	ᥤ
*/
#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/extensions/XShm.h>
#include <X11/extensions/XInput.h>
#include "xbrush.h"

void   ImageUp(), ImageDown(), ImageLeft(), ImageRight();

PRGID     *prgid;          /*  ƼΣɣ  */
BMPPALA   *bmpplm;         /*  ӥåȥޥå  */
CONSPATS  *consparts;    /*  󥽡ѡ  */

char   *cns_label[] = {(char[]){"x="},
                       (char[]){"y="},
                       (char[]){"zoom=     x"},
                       (char[]){"dens="},
                       (char[]){"size="},
                       (char[]){"R"},
                       (char[]){"G"},
		       (char[]){"B"}
                      };   /*  󥽡륦ɥΥ٥  */

char   *funcexp[] = {(char[]){"y=1"},
                     (char[]){"y=1-x^2"},
                     (char[]){"y=1-x"},
                     (char[]){"y=1-sqr(x)"}
                     };    /*  ֥饷δؿ  */


XFontStruct *info;    /*  Font Struct */
String filename;  /*  ɥե̾  */

Widget top;
Widget base;

XtActionsRec actionTable[] =
{  {"up",        (XtActionProc)ImageUp},
   {"down",      (XtActionProc)ImageDown},
   {"left",      (XtActionProc)ImageLeft},
   {"right",     (XtActionProc)ImageRight},
   {"zoomin",    (XtActionProc)ZoomIn},
   {"zoomout",   (XtActionProc)ZoomOut},
   {"key_space", (XtActionProc)Key_space},
};

char defaultTranslations[] = "<Key>Up:    up()\n\
                                     Ctrl<Key>E: up()\n\
                                     <Key>Down:  down()\n\
                                     Ctrl<Key>C: down()\n\
                                     <Key>Left:  left()\n\
                                     Ctrl<Key>S: left()\n\
                                     <Key>Right: right()\n\
                                     Ctrl<Key>F: right()\n\
                                     <Key>Insert:   zoomin()\n\
                                     Ctrl<Key>Z:    zoomin()\n\
                                     <Key>Page_Up:  zoomin()\n\
                                     <Key>Delete:   zoomout()\n\
                                     Ctrl<Key>X:    zoomout()\n\
                                     <Key>Page_Down:zoomout()\n\
                                     <Key>space: key_space()";

int  motion_type         = -1;
int  button_press_type   = -1;
int  button_release_type = -1;
int  key_press_type      = -1;
int  key_release_type    = -1;
int  proximity_in_type   = -1;
int  proximity_out_type  = -1;

/*  λ  */
void Exit_prg(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  kill(prg_id->pid, SIGINT);      /*  ֥åѻҥץνλ  */
  if( bmp_plm->disp != NULL )
      XCloseDevice(bmp_plm->disp, prg_id->xidev);  /*  XInputǥХĤ  */
  Free_bitmap(bmp_plm->org_xim);  /*  ӥåȥޥåפΥ  */
  Free_bitmap(bmp_plm->orgbuf_xim);  /*  ХåեӥåȥޥåפΥ  */
  ExitShm(bmp_plm->disp);         /*  SHMԥåޥåפ  */
  Free_bitmap(bmp_plm->imag_xim); /*  ѥӥåȥޥåפΥ  */
  Free_bitmap(bmp_plm->ibuf_xim);
                   /*  ɥåǼѥӥåȥޥåפΥ  */
  Free_bitmap(bmp_plm->undo_xim); /*  ɥӥåȥޥåפΥ  */
  Free_mask_mat(bmp_plm);         /*  ޥѥõ  */
  Free_mask_scr(bmp_plm);         /*  ޥ꡼ѥõ  */

  exit(0);
}

/*  λ (Хå)  */
void Exit(Widget w, caddr_t client_data, caddr_t call_data)
{
  Exit_prg(prgid, bmpplm, consparts);
}

/*  ̥ӥåȥޥåפκ  */
void Make_imagbmp(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  Visual    *vis;
  int       c_depth, scr, cells, planes, pixbits;
 
  DEBUG_PRINT(("Make_imagbmp()\n"));

  scr      = DefaultScreen( bmp_plm->disp );   /*  ǥեȥ꡼ֹ  */
  c_depth  = DefaultDepth(bmp_plm->disp, scr);  /*  ꡼οο  */
  planes   = DisplayPlanes(bmp_plm->disp, scr);/*  ǥץ쥤Υץ졼  */
  cells    = DisplayCells(bmp_plm->disp, scr);  /*  顼ޥåפΥ  */
  vis     = DefaultVisual(bmp_plm->disp, scr);  /*  ǥեȥӥ奢  */
  pixbits = vis->bits_per_rgb * 3;     /*  ԥӥå  */

  if( c_depth != 24 )
  {
    fprintf( stderr, " Prease Use 24depth mode \n" );
    exit(0);
  }

  Wget_wrk(prg_id->canv_wid, &bmp_plm->wid_rect);
                                            /*  ɥɽΰΰ  */

  bmp_plm->wid_size.h = bmp_plm->wid_rect.c.right - bmp_plm->wid_rect.c.left;
  bmp_plm->wid_size.v = bmp_plm->wid_rect.c.bottom - bmp_plm->wid_rect.c.top;
                                            /*  ɥɽΰ礭  */

    /*  canv_xim ν  */
  bmp_plm->canv_xim =
      CreateShmPixmap( &bmp_plm->drag_gid, NULL, prg_id->canv_wid,
			            bmp_plm->wid_size.h, bmp_plm->wid_size.v );
                                              /*  SHMԥåޥåפκ  */

  /*  imag_bmp ν  */
  if( Creat_bmp(&bmp_plm->imag_bmp, bmp_plm->wid_rect,
                             bmp_plm->org_bmp.planes, bmp_plm->pixbits)   < 0)
                                               /*    ӥåȥޥåפ    */
    Exit_prg(prg_id, bmp_plm, cons_parts);

  /*  imag_xim  XImage Ķ  */
  bmp_plm->imag_xim = CreateXImage( bmp_plm->disp,
          bmp_plm->imag_bmp.bounds.c.right - bmp_plm->imag_bmp.bounds.c.left,
          bmp_plm->imag_bmp.bounds.c.bottom - bmp_plm->imag_bmp.bounds.c.top );
                                              /*  XImageκ  */

  /*  ibuf_bmp ν  */
  if( Creat_bmp(&bmp_plm->ibuf_bmp, bmp_plm->wid_rect,
                             bmp_plm->org_bmp.planes, bmp_plm->pixbits)   < 0)
                                               /*    ӥåȥޥåפ    */
    Exit_prg(prg_id, bmp_plm, cons_parts);

  /*  ibuf_xim  XImage Ķ  */
  bmp_plm->ibuf_xim = CreateXImage( bmp_plm->disp,
          bmp_plm->ibuf_bmp.bounds.c.right - bmp_plm->ibuf_bmp.bounds.c.left,
          bmp_plm->ibuf_bmp.bounds.c.bottom - bmp_plm->ibuf_bmp.bounds.c.top );
                                              /*  XImageκ  */
}

/*  ӥåȥޥåפν  */
void    Init_orgbmp(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  PAT      clspat = {{0, 16, 16, 0x00FFFFFF, 0x00FFFFFF, FILL100}};
  Visual    *vis;
  int       c_depth, scr, cells, planes;
 
  bmp_plm->disp = XtDisplay( prg_id->canv_wid );    /*  ǥץ쥤  */
  bmp_plm->canv_gid = XtWindow( prg_id->canv_wid ); /*  ɥ  */

  scr      = DefaultScreen( bmp_plm->disp );  /*  ǥեȥ꡼ֹ  */
  c_depth  = DefaultDepth(bmp_plm->disp, scr);  /*  ꡼οο  */
  planes   = DisplayPlanes(bmp_plm->disp, scr);/*  ǥץ쥤Υץ졼  */
  cells    = DisplayCells(bmp_plm->disp, scr);  /*  顼ޥåפΥ  */
  vis     = DefaultVisual(bmp_plm->disp, scr);  /*  ǥեȥӥ奢  */
  bmp_plm->pixbits = vis->bits_per_rgb * 3;
  bmp_plm->canv_csp = DefaultColormap(bmp_plm->disp, 0);
                                                    /* 顼ޥåפ */
  //d_spec.planes = 24;
  //d_spec.pixbits = 24;

    /*  org_bmp ν  */
  if(Creat_bmp(&bmp_plm->org_bmp, bmp_plm->org_bmp.bounds,
                                             planes, bmp_plm->pixbits)     < 0)
                                               /*    ӥåȥޥåפ    */
    Exit_prg(prg_id, bmp_plm, cons_parts);

    /*  orgbuf_bmp ν  */
  if(Creat_bmp(&bmp_plm->orgbuf_bmp, bmp_plm->org_bmp.bounds,
                                             planes, bmp_plm->pixbits)     < 0)
                                               /*    ӥåȥޥåפ    */
    Exit_prg(prg_id, bmp_plm, cons_parts);


    /*  undo_bmp ν  */
  if(Creat_bmp(&bmp_plm->undo_bmp, bmp_plm->org_bmp.bounds,
                                            planes,  bmp_plm->pixbits)     < 0)
                                     /*    ɥѤΥӥåȥޥåפ    */
    Exit_prg(prg_id, bmp_plm, cons_parts);


  bmp_plm->org_size.h =
              bmp_plm->org_bmp.bounds.c.right - bmp_plm->org_bmp.bounds.c.left;
  bmp_plm->org_size.v =
              bmp_plm->org_bmp.bounds.c.bottom - bmp_plm->org_bmp.bounds.c.top;

  /*  org_xim  XImage Ķ  */
  bmp_plm->org_xim = CreateXImage( bmp_plm->disp,
          bmp_plm->org_bmp.bounds.c.right - bmp_plm->org_bmp.bounds.c.left,
          bmp_plm->org_bmp.bounds.c.bottom - bmp_plm->org_bmp.bounds.c.top );
                                              /*  XImageκ  */

  /*  orgbuf_xim  XImage Ķ  */
  bmp_plm->orgbuf_xim = CreateXImage( bmp_plm->disp,
      bmp_plm->orgbuf_bmp.bounds.c.right - bmp_plm->orgbuf_bmp.bounds.c.left,
      bmp_plm->orgbuf_bmp.bounds.c.bottom - bmp_plm->orgbuf_bmp.bounds.c.top );
                                              /*  XImageκ  */

  /*  undo_xim  XImage Ķ  */
  bmp_plm->undo_xim = CreateXImage( bmp_plm->disp,
          bmp_plm->undo_bmp.bounds.c.right - bmp_plm->undo_bmp.bounds.c.left,
          bmp_plm->undo_bmp.bounds.c.bottom - bmp_plm->undo_bmp.bounds.c.top );
                                              /*  XImageκ  */

  Gfil_rec(bmp_plm->org_xim, bmp_plm->org_bmp.bounds, &clspat, 0, 0);
                                           /*  org_gid ΰɤĤ֤  */
  Copy_org2orgbuf(bmp_plm);    /*  Хåե˵  */
  Copy_undo_bmp(bmp_plm);    /*  ɥХåե˵  */

  Make_mask_mat(bmp_plm);  /*  ޥѥ  */
}

/*  襦ɥκɽ  */
void    Redraw_canv(PRGID *prg_id, BMPPALA *bmp_plm)
{
    RECT  canv_rect;  /*  Ķΰ  */
    DCM   mode = G_STORE | G_CVFORM | G_CVCOLOR;  /*  ⡼  */
    int     err;

    DEBUG_PRINT(("Redraw_canv()\n"));

    Copy_tiles(bmp_plm->org_xim, &(bmp_plm->zoom_rect),
                 bmp_plm->imag_xim, &(bmp_plm->drw_rect), bmp_plm->zoom, mode);
                                           /*  礷ƥԡ  */

    Clr_subscreen(bmp_plm);
     /*  ɥåǼӥåȥޥåפإԡȥ֥饷ǻٲ̥ꥢ  */

    if( (prg_id->mask_mode & 0x00C0) == 0x0080 ||
                                      (prg_id->mask_mode & 0x00C0) == 0x00C0 )
    {
      if( (prg_id->mask_mode & 0x0020) == 0x0000 )
        err = Drw_Harftone(bmp_plm->imag_xim, &bmp_plm->drw_rect);
                          /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                 ̤˥ϡեȡ򤫤  */

      else if( (prg_id->mask_mode & 0x0020) == 0x0020 )
        err = Drw_Paintout(bmp_plm->imag_xim, &bmp_plm->drw_rect);
                          /*  ֥ޥΤɽפΤȤ̤ɤĤ֤  */

    }
    Gcop_bmp(bmp_plm->imag_xim, &bmp_plm->drw_rect,
                        bmp_plm->canv_xim, &bmp_plm->drw_rect, NULL, 0);
                              /*  ɥѥӥåȥޥåפإԡ  */

    Gcop_bmp(bmp_plm->imag_xim, &bmp_plm->drw_rect,
                        bmp_plm->ibuf_xim, &bmp_plm->drw_rect, NULL, 0);
                              /*  ɥåǼѥӥåȥޥåפإԡ  */

    if( (prg_id->mask_mode & 0x00C0) != 0x0000 )
    {
        Mask_disp(&bmp_plm->wid_rect, &bmp_plm->drw_rect, bmp_plm->canv_xim,
                                        bmp_plm->canv_csp, bmp_plm->mask_scr);
        /*    ̾⡼ɰʳλ,Фƥޥξ֤ȿǤ    */
    }
    XShmPutImage( bmp_plm->disp, bmp_plm->canv_gid, bmp_plm->canv_gc,
                             bmp_plm->canv_xim, 0, 0, 0, 0,
                             bmp_plm->wid_size.h, bmp_plm->wid_size.v, False );
                                            /*  ɥɽ  */

    /*Set_sclbar(prg_id->rbar_pid, prg_id->bbar_pid,
                   bmp_plm->zoom_rect, bmp_plm->org_bmp.bounds);
                                     /*  ɥС  */
    return;
}

/*  ̥ꥢ  */
void  Cls_gid(BMPPALA *bmp_plm)
{
    RECT   org_rect;  /*  Ķΰ  */
    PAT    clspat = {{0, 16, 16, WHITE, WHITE, FILL100}};
    DCM    mode = G_STORE;  /*  ⡼  */

    Gget_fra(bmp_plm->org_xim, &org_rect); /*  ĶΰĴ٤  */

    Gfil_rec(bmp_plm->org_xim, org_rect, &clspat, 0, mode);
                  /*  org_rect ǻꤷΰĹɤĤ֤  */

    Zoom(bmp_plm);    /*    ̾ɽ  */
}

/*  ̤  */
void   Draw_point(Widget wevnt, BMPPALA *bmp_plm, PRGID *prg_id,
                                                       CONSPATS *cons_parts)
{
}

void Quit_main(Widget w, XEvent *event, String *params, int num_params)
                                                           /*  Quit main  */
{
    Exit_prg( prgid, bmpplm, consparts );
}

void    Init_consdata(BMPPALA *bmp_plm, PRGID *prg_id,
                                 CONSPATS *cons_parts)    /*  Ƽ  */
{
    bmp_plm->wid_rect.c.left = PX; bmp_plm->wid_rect.c.top = PY;
    bmp_plm->wid_rect.c.right = PX + W_WIDTH;
    bmp_plm->wid_rect.c.bottom = PY + W_HEIGHT;
                                       /*  襦ɥΰ  */
    bmp_plm->cons_rect.c.left = PX1; bmp_plm->cons_rect.c.top = PY1;
    bmp_plm->cons_rect.c.right = PX1 + C_WIDTH;
    bmp_plm->cons_rect.c.bottom = PY1 + C_HEIGHT;
                                       /*  󥽡륦ɥΰ  */
    bmp_plm->zoom_rect.c.left = 0; bmp_plm->zoom_rect.c.top = 0;
    bmp_plm->zoom_rect.c.right = W_WIDTH;
    bmp_plm->zoom_rect.c.bottom = W_HEIGHT;
                                        /*  ɽΰ֤  */
    bmp_plm->zoom = 1; /*  Ψ  */
    cons_parts->funcval.func_no = 1;   /*  ؿֹ  */
    cons_parts->dens_vol.size = 255;     /*  ֥饷ǻ  */
    cons_parts->size_vol.size = 1;    /*  ֥饷礭  */
    cons_parts->slct_col.colbar[0].size = 255;   /*  ֤  */
    cons_parts->slct_col.colbar[1].size = 255;   /*  Ф  */
    cons_parts->slct_col.colbar[2].size = 255;   /*  Ĥ  */
    prg_id->xb_mode = 0x0001;             /*  ⡼  */

    prg_id->tabpnl.under =  40;    /*  ­ڤ  */
    prg_id->tabpnl.mangn = 100;    /*  Ψ  */
}

/*  襦ɥ٥  */
void    Event_canvus(Widget w, caddr_t client_data, XEvent *event)
{
  static int x0, y0, x1, y1;

  static PNT    sp, ep;    /*  ץ쥹ΰ֤ȥ꡼ΰ  */
  static PNT    sp0, ep0;
  RECT   s_rect, d_rect;    /*  ̾礭Ƚ̾礭  */
  RECT   nwid_rect;  /*  ߤΥɥ礭  */
  DCM    mode = G_STORE | G_CVFORM | G_CVCOLOR;  /*  ⡼  */
  XEvent pevent;
  Window root_w, child_w;
  int rx, ry, wx, wy;
  int  pressure;  /*  ֥åȤɮ  */
  unsigned int pointermask;

  //Draw_point(prgid->canv_wid, bmpplm, prgid, consparts);
                                                        /*  ̤  */
  switch ( event->type )
  {
    case ButtonPress:  /*  ܥ󤬲줿  */

      switch( event->xbutton.button )
      {
        case 1:  /*  ܥ󣱤줿  */
 	  if( ((prgid->mask_mode & 0x0080) == 0) ||
                 ((prgid->mask_mode & 0x00C0) == 0) )
                              /*  ޥ/õ⡼ɤǤϤʤ  */
	  {
	    if((prgid->xb_mode & 0x0020) == 0)  /*  ɥåǤʤ  */
            {
              Chgxim_orgbuf2undo(bmpplm);
	              /*  orgbuf_bmp  undo_bmp 촹  */
            }
            else if(bmpplm->org_xim == bmpplm->undolock_xim)
            {
              /*  ĶɣĤȥɥåȤ
                     ĶɣĤפȤˤϥɥХåե˥ԡ  */
              Chgxim_orgbuf2undo(bmpplm);
		        /*  orgbuf_bmp  undo_bmp 촹  */
              bmpplm->undolock_xim = bmpplm->undo_xim;
            }
	  }

          sp.x = x0 = event->xbutton.x;
          sp.y = y0 = event->xbutton.y;
          Point_brush(bmpplm, sp.x, sp.y, consparts, prgid);
                                            /*  ֥饷礭ʬ  */
          sp0 = ep0 = sp;
          prgid->xb_mode |= 0x0008;   /*  褷  */
          break;
        case 2:  /*  ܥ2줿(֥å)  */
          x0 = event->xbutton.x;
          y0 = event->xbutton.y;
	  Spoit(event, prgid, bmpplm, consparts);
          break;
        case 3:  /*  ܥ3줿  */
          x0 = event->xbutton.x;
          y0 = event->xbutton.y;
	  Spoit(event, prgid, bmpplm, consparts);
          break;
        default:
          break;
      }
      break;

    case MotionNotify:  /*  ݥ󥿤ΰư  */
      Show_pntposi(event, prgid, bmpplm, consparts);
                                      /*  ݥ󥿤ΰ֤ɽ  */

      if( (event->xmotion.state & Button1MotionMask) )
      {                     /*  ܥ󤬲줿ޤްư  */
        ep.x = x1 = event->xbutton.x; 
        ep.y = y1 = event->xbutton.y;
        Drw_brush(bmpplm, sp, ep, consparts, prgid);
        Point_brush(bmpplm, ep.x, ep.y, consparts, prgid);
                                            /*  ֥饷礭ʬ  */
        x0 = x1; y0 = y1;
        sp = ep;
        if(sp0.x > ep.x)
          sp0.x = ep.x;
        if(sp0.y > ep.y)
          sp0.y = ep.y;
        if(ep0.x < ep.x)
          ep0.x = ep.x;
        if(ep0.y < ep.y)
          ep0.y = ep.y;
      }
      break;

    case ButtonRelease:  /*  ܥΥ줿  */
      XDefineCursor( XtDisplay(prgid->cpwid), XtWindow(prgid->cpwid),
                       XCreateFontCursor(XtDisplay(prgid->cpwid), XC_watch) );
                                              /*  פѤ  */

      switch( event->xbutton.button )
      {
        case 1:  /*  ܥ󣱤Υ줿  */
          Redus_bounds(&s_rect, &d_rect, bmpplm->zoom, bmpplm->b_size,
                             sp0, ep0, bmpplm->drw_rect, bmpplm->zoom_rect);
                                         /*  褷ϰϤ׻Ƥ  */

          if( (prgid->mask_mode & 0x00C0) == 0x0000 ||
                                       (prgid->mask_mode & 0x00C0) == 0x0040 )
          {   /*  ̾⡼ɡ, ֥ޥȿ⡼ɡפξ  */
            Bmp_reduce(bmpplm->imag_xim, s_rect,
                       bmpplm->org_xim, d_rect);
             /*  ̾⡼ɡ, ֥ޥȿ⡼ɡפξ
                                               ؽ̾ƥԡ  */
            if( (prgid->mask_mode & 0x00C0) == 0x0040 )
            {                /*  ֥ޥȿפξ  */
              Gcop_bmp(bmpplm->imag_xim, &s_rect, bmpplm->canv_xim,
                                                     &s_rect, NULL, mode);
                                  /*  ӥåȥޥåפɽ̤إԡ  */
              Mask_disp(&bmpplm->wid_rect, &s_rect,
                                   bmpplm->canv_xim,
                                        bmpplm->canv_csp, bmpplm->mask_scr);
                                /*    Фƥޥξ֤ȿǤ    */
            }
          }
	  Copy_org2orgbuf(bmpplm);    /*  Хåե˵  */
          if( (prgid->mask_mode & 0x00C0) == 0x0080 ||
                                       (prgid->mask_mode & 0x00C0) == 0x00C0 )
            Save_mask(&bmpplm->wid_rect, &s_rect, bmpplm->mask_scr,
                                      &bmpplm->org_bmp.bounds, &d_rect,
                                            bmpplm->mask_mat, bmpplm->zoom);
             /*  ֥ޥ⡼ɡ, ֥ޥõ⡼ɡפξ
                               ޥ꡼󤫤ޥǡ᤹  */

          Clr_subscreen(bmpplm);
             /*  ɥåǼӥåȥޥåפإԡ
                                               ֥饷ǻٲ̥ꥢ  */

          XShmPutImage( bmpplm->disp, bmpplm->canv_gid, bmpplm->canv_gc,
                             bmpplm->canv_xim, 0, 0, 0, 0,
                             bmpplm->wid_size.h, bmpplm->wid_size.v, False );
                                            /*  ɥɽ  */
          break;
        default:
          break;
      }
      XUndefineCursor( XtDisplay(prgid->cpwid), XtWindow(prgid->cpwid) );
                                              /*  򸵤᤹  */
      break;

    case Expose:         /*  ɽ  */
      if(event->xexpose.window == bmpplm->canv_gid)
      {
        //Redraw_canv(prgid, bmpplm);   /*  襦ɥκɽ  */

        if(bmpplm->wid_rect.c.left > event->xexpose.x)
	  event->xexpose.x = bmpplm->wid_rect.c.left;
        if(bmpplm->wid_rect.c.top > event->xexpose.y)
	  event->xexpose.y = bmpplm->wid_rect.c.top;
        if(bmpplm->wid_rect.c.right < event->xexpose.width)
	  event->xexpose.width = bmpplm->wid_rect.c.right;
        if(bmpplm->wid_rect.c.bottom < event->xexpose.height)
	  event->xexpose.height = bmpplm->wid_rect.c.bottom;

        XShmPutImage( bmpplm->disp, bmpplm->canv_gid, bmpplm->canv_gc,
                      bmpplm->canv_xim, event->xexpose.x, event->xexpose.y,
                                        event->xexpose.x, event->xexpose.y,
                      event->xexpose.width,  event->xexpose.height, False );
                                            /*  ɥɽ  */
        Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  ɥС  */

        if( XtIsRealized(prgid->automsk.main_pnl))
          Automask_pnl(consparts);  /*  ưޥκɽ  */
        if( XtIsRealized(prgid->tabpnl.main_pnl) )
          Tabletto_pnl(consparts, prgid);
                                   /*  ֥åκɽ  */
      }
      break;

    case ConfigureNotify:         /*  ɥѲ  */
      Wget_wrk(prgid->canv_wid, &nwid_rect);
                                            /*  ɥɽΰΰ  */
      if(  ((nwid_rect.c.right - nwid_rect.c.left) ==
                   (bmpplm->wid_rect.c.right - bmpplm->wid_rect.c.left)) &&
           ((nwid_rect.c.bottom - nwid_rect.c.top) ==
                   (bmpplm->wid_rect.c.bottom - bmpplm->wid_rect.c.top)) )
	break; /*  ɥ礭Ʊä  */

      XDefineCursor( XtDisplay(prgid->pwid), XtWindow(prgid->pwid),
                       XCreateFontCursor(XtDisplay(prgid->pwid), XC_watch) );
                                              /*  פѤ  */
      Wget_wrk(prgid->canv_wid, &bmpplm->wid_rect);
                                            /*  ɥɽΰΰ  */
      Wget_wrk(prgid->cons_wid, &bmpplm->cons_rect);
                                  /*  󥽡륦ɥɽΰΰ  */
      Chg_conssize(prgid, bmpplm, consparts);
                                /*  󥽡륦ɥ礭ѹ  */
      Chg_windsize(prgid, bmpplm, consparts);
                                /*  ɽɥ礭ѹ  */
      /*Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  ɥС  */
      XUndefineCursor( XtDisplay(prgid->pwid), XtWindow(prgid->pwid) );
                                              /*  򸵤᤹  */
      break;

    case ClientMessage:    /*  饤ȥå  */
      break;

    default:
      break;
    }
}

void ImageUp(Widget w, XEvent *event, String *params, int num_params)
                                                      /*  Vsual Point Up  */
{
  Imag_mov(bmpplm, 0); /*  ɽ֤ΰư  */

  Rest_mask(&bmpplm->org_bmp.bounds, &bmpplm->zoom_rect, bmpplm->mask_mat,
              &bmpplm->wid_rect, &bmpplm->drw_rect, bmpplm->mask_scr,
                                                                bmpplm->zoom);
                                    /*  ޥ̤ޥ꡼  */

  Harf_tone(prgid->mask_mode, bmpplm);
                /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                ̤˥ϡեȡ򤫤  */
  Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  ɥС  */
}

void ImageDown(Widget w, XEvent *event, String *params, int num_params)
                                                      /*  Vsual Point Down  */
{
  Imag_mov(bmpplm, 1); /*  ɽ֤ΰư  */

  Rest_mask(&bmpplm->org_bmp.bounds, &bmpplm->zoom_rect, bmpplm->mask_mat,
              &bmpplm->wid_rect, &bmpplm->drw_rect, bmpplm->mask_scr,
                                                                bmpplm->zoom);
                                    /*  ޥ̤ޥ꡼  */

  Harf_tone(prgid->mask_mode, bmpplm);
                /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                ̤˥ϡեȡ򤫤  */
  Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  ɥС  */
}

void ImageRight(Widget w, XEvent *event, String *params, int num_params)
                                                     /*  Vsual Point Right  */
{
  Imag_mov(bmpplm, 2); /*  ɽ֤ΰư  */

  Rest_mask(&bmpplm->org_bmp.bounds, &bmpplm->zoom_rect, bmpplm->mask_mat,
              &bmpplm->wid_rect, &bmpplm->drw_rect, bmpplm->mask_scr,
                                                                bmpplm->zoom);
                                    /*  ޥ̤ޥ꡼  */

  Harf_tone(prgid->mask_mode, bmpplm);
                /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                ̤˥ϡեȡ򤫤  */
  Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  ɥС  */
}

void ImageLeft(Widget w, XEvent *event, String *params, int num_params)
                                                     /*  Vsual Point Left  */
{
  Imag_mov(bmpplm, 3); /*  ɽ֤ΰư  */

  Rest_mask(&bmpplm->org_bmp.bounds, &bmpplm->zoom_rect, bmpplm->mask_mat,
              &bmpplm->wid_rect, &bmpplm->drw_rect, bmpplm->mask_scr,
                                                                bmpplm->zoom);
                                    /*  ޥ̤ޥ꡼  */

  Harf_tone(prgid->mask_mode, bmpplm);
                /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                ̤˥ϡեȡ򤫤  */
  Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  ɥС  */
}

/*  ٥ȥ롼  */
void    Evtloop(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  XEvent    event;
  int  pressure;  /*  ֥åȤɮ  */

  DEBUG_PRINT(("Evtloop()\n"));

  while(1)
  {
    XtNextEvent(&event);  /*  ٥Ȥ  */
    //DEBUG_PRINT(("Evtloop()  event.type:%d\n", event.type));
    if ( event.type == motion_type )
    {
      XDeviceMotionEvent *motion = (XDeviceMotionEvent *) &event;

      bmpplm->presser = motion->axis_data[2];
      DEBUG_PRINT(("Evtloop()  %d %d %d\n", motion->axis_data[0], motion->axis_data[1], motion->axis_data[2]));
    }

    XtDispatchEvent(&event);
  }

}

/*  ɥСν  */
void Init_canvbar(Widget pwid, PRGID *prg_id, BMPPALA *bmp_plm)
{
  static  char  defaultTranslations[] =
    "<Btn1Down> : StartScroll(Continuos)MoveThumb()NotifyThumb() \n\
     <Btn1Motion> : MoveThumb()NotifyThumb()";
  XtTranslations trans_table;

  static  XtCallbackRec  callback[] =
  { {(XtCallbackProc)Wscr_evn, NULL},
    {NULL, NULL},
  };

  prg_id->rbar_pid = XtVaCreateManagedWidget("rbar", scrollbarWidgetClass,
                            pwid,
			    //XtNlength,        bmp_plm->wid_rect.c.bottom
                            //                   - bmp_plm->wid_rect.c.top,
                            //XtNthickness,     (XtArgVal)10,
			    XtNwidth,     (XtArgVal)10,
			    XtNheight,        bmp_plm->wid_rect.c.bottom
					        - bmp_plm->wid_rect.c.top,
                            XtNjumpProc,      (XtArgVal)callback,
			    XtNbackground,    (XtArgVal)DGRAY,
			    XtNtop,    XawChainTop,
			    //XtNbottom, XawChainTop,
			    XtNleft,   XawChainRight,
			    XtNright,  XawChainRight,
			    XtNshown,         10,
			    XtNfromHoriz,  prg_id->canv_wid,
			    XtNfromVert,  NULL,
			    XtNhorizDistance, 0,
			    XtNvertDistance,  0,
			    NULL);
                                        /*  ܥ塼  */

  prg_id->bbar_pid = XtVaCreateManagedWidget("bbar", scrollbarWidgetClass,
                            pwid,
                            XtNorientation,(XtArgVal)XtorientHorizontal,
			    //XtNlength,        bmp_plm->wid_rect.c.right
					     //- bmp_plm->wid_rect.c.left,
			    //XtNthickness,     (XtArgVal)10,
			    XtNwidth,        bmp_plm->wid_rect.c.right
			    	          - bmp_plm->wid_rect.c.left,
			    XtNheight,     (XtArgVal)10,
                            XtNjumpProc,      (XtArgVal)callback,
			    XtNbackground,    (XtArgVal)DGRAY,
			    XtNtop,    XawChainBottom,
			    XtNbottom, XawChainBottom,
			    XtNleft,   XawChainLeft,
			    //XtNright, XawChainLeft,
			    XtNshown,         10,
			    XtNfromHoriz,  NULL,
			    XtNfromVert,  prg_id->canv_wid,
			    XtNhorizDistance, 0,
			    XtNvertDistance,  0,
			    NULL);
                                        /*  ܥ塼  */

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(prg_id->rbar_pid, trans_table);
  XtOverrideTranslations(prg_id->bbar_pid, trans_table);
}

//ܸ첽ΤΥ꥽
char *resources[] = {
	"*international: True",//ݲ
	"*fontSet: -*-*-*-*-*--18-*",//եȤλ 
	"*preeditType: OverTheSpot,OffTheSpot,Root",//ܸϤɽ 
	"*inputMethod: kinput2",//ϤΥץ
	NULL
};

int main(int argc, char *argv[])
{
  PRGID     prg_id;        /*  ƼΣɣ  */
  BMPPALA   bmp_plm;       /*  ӥåȥޥå  */
  CONSPATS  cons_parts;    /*  󥽡ѡ  */

  static XtActionsRec actions[] = {{"close", (XtActionProc)Quit_main}};
  static Atom wm_delete_window;
  XtTranslations trans_table;
  static char *dev;  /*  XInput ѤΥǥХ̾Υݥ󥿤Ƥ  */
  int i, width, height;

  bmpplm = &bmp_plm;  prgid = &prg_id;  consparts = &cons_parts;

  Init_consdata(&bmp_plm, &prg_id, &cons_parts);    /*  Ƽ  */

  bmp_plm.wid_size.h = W_WIDTH;
  bmp_plm.wid_size.v = W_HEIGHT;
  bmp_plm.org_bmp.bounds.c.left   = 0;
  bmp_plm.org_bmp.bounds.c.right  = bmp_plm.wid_size.h;
  bmp_plm.org_bmp.bounds.c.top    = 0;
  bmp_plm.org_bmp.bounds.c.bottom = bmp_plm.wid_size.v;

  for( i = 1; i < argc; i ++ )
  {
    if( i + 1 < argc && strcmp( argv[i], "-x" ) == 0 )
    {
      width = atoi(argv[++i]);
      if( width != 0 )
	bmp_plm.org_bmp.bounds.c.right = width;
    }
    if( i + 1 < argc && strcmp( argv[i], "-y" ) == 0 )
    {
      height = atoi(argv[++i]);
      if( height != 0 )
	bmp_plm.org_bmp.bounds.c.bottom = height;
    }
    if( i + 1 < argc && strcmp( argv[i], "-device" ) == 0 )
    {
      dev = argv[++i];  /*  ǥХλ꤬ͭä  */
    }
    filename = argv[i];  /*  ե̾äƤ  */
  }

  XtSetLanguageProc (NULL, NULL, NULL);  /*  ݲν  */

  top         = XtInitialize(argv[0], "Xbrush", NULL, 0, &argc, argv);

  //top         = XtVaAppInitialize(&prg_id.app_context, "Xbrush", NULL, 0, &argc, argv,
//				  NULL, NULL);


  prg_id.pwid = XtVaCreateManagedWidget("pwid", formWidgetClass, top,
				    XtNbackground,  GRAY,
					NULL);
  info = XLoadQueryFont( XtDisplay( prg_id.pwid ), "-*--13-*" );

  prg_id.cons_wid = XtVaCreateManagedWidget("Console_wid", formWidgetClass,
                                    prg_id.pwid,
				    XtNwidth, bmp_plm.cons_rect.c.right
					        - bmp_plm.cons_rect.c.left,
				    XtNheight, bmp_plm.cons_rect.c.bottom
					        - bmp_plm.cons_rect.c.top,
				    XtNtop,    XtChainTop,
				    XtNbottom, XtChainBottom,
				    XtNleft,   XtChainLeft,
				    XtNright,  XtChainLeft,
				    XtNbackground,  GRAY,
				    NULL);

  prg_id.cpwid = XtVaCreateManagedWidget("Canv_pwid", formWidgetClass,
                                  prg_id.pwid,
			          XtNresizable,    True,
				  XtNfromHoriz,  prg_id.cons_wid,
				  //XtNfromVert, prg_id.pwid,
				  XtNtop,    XtChainTop,
				  XtNbottom, XtChainBottom,
				  XtNleft,   XtChainLeft,
				  XtNright,  XtChainRight,
			          XtNdefaultDistance, 0,
				  XtNbackground,  GRAY,
			          NULL);

  prg_id.canv_wid = XtVaCreateManagedWidget("Canvas_wid", formWidgetClass,
                                  prg_id.cpwid,
			          XtNwidth, bmp_plm.wid_rect.c.right
                                                  - bmp_plm.wid_rect.c.left,
			          XtNheight, bmp_plm.wid_rect.c.bottom
                                                  - bmp_plm.wid_rect.c.top,
			          XtNresizable,    True,
			          XtNhorizDistance, 0,
			          XtNvertDistance,  0,
				  //XtNfromHoriz, prg_id.cons_wid,
				  //XtNfromVert, prg_id.pwid,
			          XtNtop,    XtChainTop,
			          XtNbottom, XtChainBottom,
			          XtNleft,   XtChainLeft,
				  XtNright,  XtChainRight,
			          NULL);

  Init_canvbar(prg_id.cpwid, &prg_id, &bmp_plm);  /*  ХСν  */

  bmp_plm.canv_gc = DefaultGC( XtDisplay( prg_id.canv_wid ),
                               DefaultScreen( XtDisplay( prg_id.canv_wid ) ) );
  bmp_plm.cons_gc = DefaultGC( XtDisplay( prg_id.cons_wid ),
                               DefaultScreen( XtDisplay( prg_id.cons_wid ) ) );

  bmp_plm.fnt = XLoadFont( XtDisplay( prg_id.cons_wid ), "-*-bold-*--13-*" );

  XtAddActions( actionTable, XtNumber(actionTable) );
  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations( prg_id.pwid, trans_table );

  XtAddEventHandler( prg_id.cons_wid, ButtonPressMask | ButtonReleaseMask
                                      | LeaveNotify | ExposureMask,
                    False, (XtEventHandler)Event_cons, NULL );  /* 󥽡ؤΥ٥ȥϥɥ */

  XtAddEventHandler( prg_id.canv_wid,
                    ButtonPressMask | Button1MotionMask | PointerMotionMask
		    | ExposureMask | ButtonReleaseMask | StructureNotifyMask
                    | ResizeRedirectMask,
                    True, (XtEventHandler)Event_canvus, NULL );  /* ХؤΥ٥ȥϥɥ */

  XtAddActions( actions, XtNumber(actions) );
  XtOverrideTranslations( top,
      XtParseTranslationTable("<Message>WM_PROTOCOLS: close()"));
  wm_delete_window = XInternAtom(XtDisplay(top), "WM_DELETE_WINDOW", False);

  XtRealizeWidget(top);

  XSetWMProtocols( XtDisplay(top), XtWindow(top), &wm_delete_window, 1 );

  XDefineCursor( XtDisplay(prgid->pwid), XtWindow(prgid->pwid),
                       XCreateFontCursor(XtDisplay(prgid->pwid), XC_watch) );
                                              /*  פѤ  */

  Wget_wrk(prg_id.canv_wid, &bmp_plm.wid_rect);
                                            /*  ɥɽΰΰ  */

  Init_orgbmp(&prg_id, &bmp_plm, &cons_parts);
                                            /*  ӥåȥޥåפν  */

  Make_imagbmp(&prg_id, &bmp_plm, &cons_parts);
                                           /*  ̥ӥåȥޥåפκ  */

  Make_brush_scr(&bmp_plm);     /*  ֥饷꡼κ  */

  Make_rgbcolor_scr(&bmp_plm);  /*  RGB顼꡼κ  */

  Cpy_org2img(&bmp_plm);
                     /*  Ȳإԡȥ֥饷ǻٲ̥ꥢ  */

  Make_mask_scr(&bmp_plm); /*  ޥ꡼ѥ  */
  prg_id.mask_mode = 0x0000; /*  ޥ⡼ɤꥻåȤ  */

  Init_maskpnl(&cons_parts.maskpnl);    /*  ưޥѥͥν  */

  Init_conspt(&prg_id, &bmp_plm, &cons_parts);
                                   /*  󥽡ΥѡĤν  */
  Disp_consw(bmp_plm.cons_gc, &cons_parts);
                                   /*  󥽡륦ɥɽ  */

  Set_menu(&prg_id, &bmp_plm);    /*  ˥塼Ͽ  */

  Show_zoom(&bmp_plm, &cons_parts);     /*  Ψɽ  */

  Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  С  */

  XUndefineCursor( XtDisplay(prgid->pwid), XtWindow(prgid->pwid) );
                                              /*  򸵤᤹  */

  if(filename != NULL)  /*  ե͡बäƤ  */
    Loadfile(filename, &bmp_plm, &prg_id);  /*  ե  */

  if( Settabletto(&bmp_plm, &prg_id, dev) > 0 )
  {                              /*  ֥åȤȤ뤫ɤ  */
    prg_id.xb_mode |= 0x0010;
    DEBUG_PRINT(("Tabletto can use\n"));
  }

  Evtloop(&prg_id, &bmp_plm, &cons_parts);  /*  ᥤ󥤥٥ȥ롼  */

  return(0);
}
