#include <stdlib.h>
#include <stdio.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/extensions/XShm.h>
#include "xbrush.h"

extern PRGID     *prgid;        /*  $B3F<o$N#I#D(B  */
extern BMPPALA   *bmpplm;       /*  $B%S%C%H%^%C%W(B  */
extern CONSPATS  *consparts;    /*  $B%3%s%=!<%k%Q!<%D(B  */

/*  $B:n6H2hA|$H%I%i%C%0Cf0l;~3JG<MQ2hA|$N:F@_Dj(B  */
void    Chg_cspec(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  //gcls_env(bmp_plm->imag_gid);  /*  $B:n6HIA2h4D6-$N:o=|(B  */
  //gcls_env(bmp_plm->ibuf_gid);  /*  $B%I%i%C%03JG<MQIA2h4D6-$N:o=|(B  */

  DEBUG_PRINT(("Chg_cspec()\n"));
    ExitShm(bmp_plm->disp);  /*  SHM$B%T%C%/%9%^%C%W$r3+J|(B  */
    Free_bitmap(bmp_plm->imag_xim);  /*  $B%S%C%H%^%C%W$N%a%b%j$r3+J|(B  */
    Free_bitmap(bmp_plm->ibuf_xim);  /*  $B%S%C%H%^%C%W$N%a%b%j$r3+J|(B  */

    Make_imagbmp(prg_id, bmp_plm, cons_parts);   /*  $B2hLL%S%C%H%^%C%W$N:n@.(B  */
}

/*  $BI=<(%&%#%s%I%&$NBg$-$5JQ99(B  */
void    Chg_windsize(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  Display *dsp;
  Window   win;
  int x, y;

  DEBUG_PRINT(("Chg_windsize()\n"));

  dsp = XtDisplay( prg_id->pwid );
  win = XtWindow( prg_id->canv_wid );

  /*
  XGetGeometry( bmp_plm->disp, bmp_plm->canv_gid, &root, &x, &y,
                                      &width, &height, &border, &depth );
                                      /*  $B%&%#%s%I%&I=<(NN0h$N<h$j=P$7(B  */

  Free_mask_scr(bmp_plm);         /*  $B%^%9%/%9%/%j!<%sMQ%a%b%j>C5n(B  */
  free(bmp_plm->brush_scr);      /*  $B2hLL$N%V%i%7G;EY2hLL$N%a%b%j$r3+J|(B  */
  free(bmp_plm->rgbcolor_scr);   /*  RGB$B%+%i!<%/%j!<%s$N%a%b%j$r3+J|(B  */

  Chg_cspec(prg_id, bmp_plm, cons_parts);
                             /*  $B:n6H2hA|$H%I%i%C%0Cf0l;~3JG<MQ2hA|$N:F@_Dj(B  */

  Make_brush_scr(bmp_plm);      /*  $B%V%i%7%9%/%j!<%s$N:n@.(B  */
  Make_rgbcolor_scr(bmp_plm);   /*  RGB$B%+%i!<%/%j!<%s$N:n@.(B  */

  Zoom_point(bmp_plm);     /*    $BI=<($9$kJ,$N<B:]$N2hA|$NNN0h$r7W;;$9$k(B    */

  Zoom(bmp_plm);   /*    $B3HBg=L>.I=<((B  */

  Make_mask_scr(bmp_plm);       /*  $B%^%9%/%9%/%j!<%sMQ%a%b%j:n@.(B  */
  Redraw_canv(prg_id, bmp_plm);   /*  $BIA2h%&%#%s%I%&$N:FI=<((B  */
}

/*    $B%S%C%H%^%C%W$r:n@.(B    */
int  Creat_bmp(BMP *bmp, RECT rect, short planes, short pixbits)
{
    int    size_h, size_v;  /*  rect $B$NI}$H9b$5(B  */

    bmp->planes   =  planes;   /*  $B%W%l!<%s?t(B  */
    bmp->pixbits  =  pixbits;   /*  $B%T%/%;%k%S%C%H?t(B($B6-3&(B/$BM-8z(B)  */
    bmp->bounds.c.left   =  rect.c.left;
    bmp->bounds.c.right  =  rect.c.right;
    bmp->bounds.c.top    =  rect.c.top;
    bmp->bounds.c.bottom =  rect.c.bottom;

    size_h        =  bmp->bounds.c.right - bmp->bounds.c.left;
    size_v        =  bmp->bounds.c.bottom - bmp->bounds.c.top;

    bmp->rowbytes = size_h * (( ((pixbits + 7)/ 8) + 1) / 2) * 2;
                                     /*  $B%W%l!<%s$N2#$N%P%$%H?t(B  */
    if( (bmp->baseaddr = malloc(sizeof(unsigned char) * bmp->rowbytes * size_v))
                                                                    == NULL )
      return(-1);

    return(0);
}

/*    $B862hA|$r3HBg$7$F%3%T!<$9$k(B  */
void    Copy_tiles(XImage *src_xim, RECT *src_rect,
                     XImage *dst_xim, RECT *dst_rect, int zoom, int mode)
  /*  src_gid $B$N(B src_rect $B$r(B zoom $BG\$K$7$F(B dst_gid $B$X(Bmode $B$NIA2h%b!<%I$G(B
      $BE=$jIU$1$k!#(B
      $B$O$_=P$9%I%C%H$O!"8DJL$KE,EY$K3HBg$7$FE=$jIU$1!#(B  */
{
    RECT    s0, s1, s2, s3;    /*  $B%3%T!<85$ND9J}7AHO0O(B  */
    RECT    d0, d1, d2, d3;    /*  $B%3%T!<@h$ND9J}7AHO0O(B  */

  DEBUG_PRINT(("Copy_tiles()\n"));

    /*  $B:8>e$NHO0O(B  */
    s0.c.left = src_rect->c.left;  s0.c.right  = src_rect->c.right;
    s0.c.top  = src_rect->c.top;   s0.c.bottom = src_rect->c.bottom;

    d0.c.left = dst_rect->c.left;
    d0.c.top = dst_rect->c.top;
    d0.c.right = d0.c.left + (src_rect->c.right - src_rect->c.left) * zoom;
    d0.c.bottom = d0.c.top + (src_rect->c.bottom - src_rect->c.top) * zoom;

    if((d0.c.right - d0.c.left) > (dst_rect->c.right - dst_rect->c.left))
    {
        s0.c.right -= 1;
        d0.c.right -= zoom;
    }
    if((d0.c.bottom - d0.c.top) > (dst_rect->c.bottom - dst_rect->c.top))
    {
        s0.c.bottom -= 1;
        d0.c.bottom -= zoom;
    }
    Gcop_bmp(src_xim, &s0, dst_xim, &d0, NULL, mode);
                                                   /*  $B3HBg!?=L>.%3%T!<(B  */

    /*  $B1&>e$NHO0O(B  */
    s1.c.left = s0.c.right;  s1.c.right  = src_rect->c.right;
    s1.c.top  = s0.c.top;    s1.c.bottom = s0.c.bottom;

    d1.c.left = d0.c.right;  d1.c.right  = dst_rect->c.right;
    d1.c.top  = d0.c.top;    d1.c.bottom = d0.c.bottom;

    Gcop_bmp(src_xim, &s1, dst_xim, &d1, NULL, mode);
                                                   /*  $B3HBg!?=L>.%3%T!<(B  */

    /*  $B:82<$NHO0O(B  */
    s2.c.left = s0.c.left;    s2.c.right  = s0.c.right;
    s2.c.top  = s0.c.bottom;  s2.c.bottom = src_rect->c.bottom;

    d2.c.left = d0.c.left;    d2.c.right  = d0.c.right;
    d2.c.top  = d0.c.bottom;  d2.c.bottom = dst_rect->c.bottom;

    Gcop_bmp(src_xim, &s2, dst_xim, &d2, NULL, mode);
                                                   /*  $B3HBg!?=L>.%3%T!<(B  */

    /*  $B1&2<$NHO0O(B  */
    s3.c.left = s0.c.right;   s3.c.right  = src_rect->c.right;
    s3.c.top  = s0.c.bottom;  s3.c.bottom = src_rect->c.bottom;

    d3.c.left = d0.c.right;   d3.c.right  = dst_rect->c.right;
    d3.c.top  = d0.c.bottom;  d3.c.bottom = dst_rect->c.bottom;

    Gcop_bmp(src_xim, &s3, dst_xim, &d3, NULL, mode);
                                                   /*  $B3HBg!?=L>.%3%T!<(B  */
}

/*  $B%]%$%s%?$N0LCV$rI=<($9$k(B  */
void Show_pntposi(XEvent *wevnt, PRGID *prg_id,
                            BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  Arg  args_x[1], args_y[1];
  char  label_x[5], label_y[5];
  int    pos_x, pos_y;

  pos_x = bmp_plm->zoom_rect.c.left
              + (wevnt->xbutton.x - bmp_plm->drw_rect.c.left) / bmp_plm->zoom;
  pos_y = bmp_plm->zoom_rect.c.top
              + (wevnt->xbutton.y - bmp_plm->drw_rect.c.top) / bmp_plm->zoom;
                         /*  $B2hA|$KBP$9$k<B:]$N%]%$%s%?$N0LCV$r7W;;$7$F$$$k(B  */

  sprintf( label_x, "%d", pos_x );
  sprintf( label_y, "%d", pos_y );

  XtSetArg( args_x[0], XtNlabel, (XtArgVal)label_x );
  XtSetArg( args_y[0], XtNlabel, (XtArgVal)label_y );

  XtSetValues( cons_parts->point_pnt.numx_pid, args_x, XtNumber(args_x) );
  XtSetValues( cons_parts->point_pnt.numy_pid, args_y, XtNumber(args_y) );
                                              /*  $B?tCM%\%C%/%9$X@_Dj(B  */
}

/*  $B3HBgN($rI=<($9$k(B  */
void    Show_zoom(BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  Arg  args[1];
  char  label[4];

  sprintf( label, "%d", bmp_plm->zoom );

  XtSetArg( args[0], XtNlabel, (XtArgVal)label );
  XtSetValues( cons_parts->zoom_num.num_pid, args, XtNumber(args) );
                                              /*  $B%i%Y%k%&%#%8%C%H$X@_Dj(B  */
}

/*  gid $B$N(B pos $B$X(B cv_col[] $B$rIA$-9~$`(B  */
void  Putrgb(XImage *image, PNT pos, CSPEC csp,
                                         unsigned long cv_col[])
{
    //PIXVAL  pix;     /*  $B%T%/%;%kCM(B  */
    unsigned long   col;     /*  $BIA$-9~$`%+%i!<CM(B  */
    DCM   mode = G_STORE;  /*  $BIA2h%b!<%I(B  */

    col = cv_col[0] << 16 | cv_col[1] << 8 | cv_col[2];
                                       /*  $BJ?6Q2=$7$?#R#G#BCM$r=P$7$F$$$k(B  */
    //pix = toPixel( col, &csp );      /*  $B#R#G#BCM$r%T%/%;%kCM$XJQ49(B  */
    //if(col != 0xffffff)

    XPutPixel(image, pos.x, pos.y, col); /*  $BE@$rIA$-9~$`(B  */
}

/*  $B3F?'$N%T%/%;%kCM$r<h$j=P$9(B  */
unsigned long Getpixels(XImage *image, PNT pos, CSPEC csp,
                                         unsigned long cv_col[])
{
    int    i;
    //PIXVAL  pix;     /*  $B%&%#%s%I%&$+$i<h$j=P$7$?%T%/%;%kCM$rF~$l$k(B  */
    unsigned long   col;     /*  $B<h$j=P$7$??'$N%+%i!<CM(B  */

    col = XGetPixel(image, pos.x, pos.y); /*  $B2hA|$+$i?'$r<h$j=P$9(B  */

    //col = toRGB(pix, &csp);            /*  $B%T%/%;%kCM$+$i#R#G#BCM$XJQ49(B  */

    for(i = 0; i < 3; i++)
    {
        cv_col[i] = (col >> ((2-i) * 8)) & 0xFF;
                        /*  $B:n6H2hA|$N#R#G#B$=$l$>$l$N%T%/%;%kCM$r<h$j=P$9(B  */
    }
    return(col);  /*  $B%+%i!<CM$rLa$9(B  */
}

/*  $B%9%]%$%H5!G=(B  */
void     Spoit(XEvent *wevnt, PRGID *prg_id,
                      BMPPALA *bmp_plm, CONSPATS *cons_parts)

{
  int x, y, i;
  unsigned int col[3];
  unsigned long c_pixel;
  float per[3];

  x = wevnt->xbutton.x; y = wevnt->xbutton.y;
  c_pixel = XGetPixel( bmp_plm->imag_xim, x, y );
                                             /*  $B3F?'$N%T%/%;%kCM$r<h$j=P$9(B  */

  col[0] = ( c_pixel & 0x00ff0000 ) >> 16;
  col[1] = ( c_pixel & 0x0000ff00 ) >> 8;
  col[2] = c_pixel & 0x000000ff;

  for(i = 0; i < 3 ; i ++)
  {
    per[i] = (float)(255 - col[i]) / 255;
    cons_parts->slct_col.colbar[i].size = col[i];
                                              /*  $B%\%j%e!<%`$NCM$rF~$l$k(B  */

    XawScrollbarSetThumb( cons_parts->slct_col.colbar[i].vol_pid,
                                                         per[i], 0.0 );
                                                     /*  $B%\%j%e!<%`$X@_Dj(B  */

    Vol_evn((Widget)NULL, cons_parts->slct_col.colbar[i].vol_pid,
                             &cons_parts->slct_col.colbar[i],
	                     bmp_plm, cons_parts);/*  $B%\%j%e!<%`%$%Y%s%H(B  */
  }
  Shw_color(bmp_plm, cons_parts);  /*  $BA*Br?'$N@_Dj(B  */
}

/*  $B862hA|$+$i:n6H2hA|$X%3%T!<$H(B,$B%V%i%7G;EY2hLL%/%j%"(B  */
void    Cpy_org2img(BMPPALA *bmp_plm)
{
    DCM   mode = G_STORE;  /*  $BIA2h%b!<%I(B  */
    PAT   clspat = {{0, 16, 16, 0x00a0a0a0, 0x00a0a0a0, FILL100}};

  DEBUG_PRINT(("Cpy_org2img()\n"));

    memset(bmp_plm->brush_scr, 0x00,
                     bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(char));
                            /*  $B%V%i%7G;EYMQ2hLL$N=i4|2=(B  */
    memset(bmp_plm->rgbcolor_scr, 0x00,
                     bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(long));
                            /*  RGB$B%+%i!<%9%/%j!<%sMQ2hLL$N=i4|2=(B  */

    Gfil_rec(bmp_plm->imag_xim, bmp_plm->imag_bmp.bounds, &clspat, 0, mode);
                                          /*  imag_gid $B$NNN0h$rEI$j$D$V$9(B  */

    Gfil_rec(bmp_plm->ibuf_xim, bmp_plm->imag_bmp.bounds, &clspat, 0, mode);
                                          /*  ibuf_gid $B$NNN0h$rEI$j$D$V$9(B  */

    Zoom(bmp_plm);   /*    $B3HBg=L>.I=<((B  */
}

/*  $B%I%i%C%0Cf0l;~3JG<MQIA2h%S%C%H%^%C%W$X%3%T!<$H%V%i%7G;EY2hLL%/%j%"(B  */
void Clr_subscreen(BMPPALA *bmp_plm)
{
  int pixel_byte;

  //pixel_byte = bmp_plm->imag_bmp.pixbits / 8;

    RECT  wid_rect;   /*  $BIA2h4D6-$NNN0h(B  */
    int   mode = 0;  /*  $BIA2h%b!<%I(B  */

  DEBUG_PRINT(("Clr_subscreen()\n"));

    //gget_fra(bmp_plm->imag_gid, &wid_rect); /*  $B85IA2h4D6-$NNN0h$rD4$Y$k(B  */

    wid_rect.c.left = 0;  wid_rect.c.right = bmp_plm->wid_size.h;
    wid_rect.c.top = 0;  wid_rect.c.bottom = bmp_plm->wid_size.v;

    Gcop_bmp(bmp_plm->imag_xim, &wid_rect, bmp_plm->ibuf_xim,
                                                  &wid_rect, NULL, mode);
                              /*  $B%I%i%C%0Cf0l;~3JG<MQ%S%C%H%^%C%W$X%3%T!<(B  */

    memset(bmp_plm->brush_scr, 0x00,
                    bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(char));
                            /*  $B%V%i%7G;EYMQ2hLL$N=i4|2=(B  */

    memset(bmp_plm->rgbcolor_scr, 0x00,
                    bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(long));
                            /*  RGB$B%+%i!<%9%/%j!<%sMQ2hLL$N=i4|2=(B  */

  /*
  for( i = 0; i < bmp_plm.wid_size.v; i ++ )
    memcpy( image_screen + i * bmp_plm.wid_size.h * pixel_byte,
	    bmp_plm.imag_bmp->data + i * bmp_plm.imag_bmp->bytes_per_line,
	    bmp_plm.wid_size.h * pixel_byte );
  */

  /*
  for( i = 0; i < bmp_plm->wid_size.v; i ++ )
  {
    memcpy( bmp_plm->ibuf_bmp.baseaddr + i * bmp_plm->imag_bmp.rowbytes,
	    bmp_plm->imag_bmp.baseaddr + i * bmp_plm->imag_bmp.rowbytes,
	    bmp_plm->wid_size.h * pixel_byte );
  }
  */
}

/*  $B%&%#%s%I%&%9%/%m!<%k%P!<$N@_Dj(B  */
void    Set_sclbar(Widget rbar_pid, Widget bbar_pid,
                                        RECT wid_rect, RECT img_rect)
{
  Arg  args[1];
  float per, thumb;
  
  per = (float)( (float)wid_rect.c.top /
                    (float)(img_rect.c.bottom - img_rect.c.top) );

  thumb = (float)( (float)(wid_rect.c.bottom - wid_rect.c.top) /
                      (float)(img_rect.c.bottom - img_rect.c.top) );
  if(per < 0) per = 0;  if(per > 1) per = 1;
  if(thumb < 0) thumb = 0;  if(thumb > 1) thumb = 1;

  XawScrollbarSetThumb( rbar_pid, per, thumb );
                                   /*  $B>e2<J}8~%\%j%e!<%`$X@_Dj(B  */

  per = (float)( (float)wid_rect.c.left /
                    (float)(img_rect.c.right - img_rect.c.left) );
  thumb = (float)( (float)(wid_rect.c.right - wid_rect.c.left) / 
                      (float)(img_rect.c.right - img_rect.c.left) );
  if(per < 0) per = 0;  if(per > 1) per = 1;
  if(thumb < 0) thumb = 0;  if(thumb > 1) thumb = 1;

  XawScrollbarSetThumb( bbar_pid, per, thumb );
                                   /*  $B:81&J}8~%\%j%e!<%`$X@_Dj(B  */
}

/*  $B%\%j%e!<%`$NCM$rH?1G$5$;$k(B  */
void    Put_volval(int dirc, int *value, BMPPALA *bmp_plm, PRGID *prg_id)
{
    if(dirc == 0)    /*  $B:81&J}8~$X$N%8%c%s%W(B  */
    {
        bmp_plm->zoom_rect.c.left  = value[1];
        bmp_plm->zoom_rect.c.right = value[0];
    }
    else if(dirc == 1)    /*  $B>e2<J}8~$X$N%8%c%s%W(B  */
    {
        bmp_plm->zoom_rect.c.top    = value[0];
        bmp_plm->zoom_rect.c.bottom = value[1];
    }
}

/*  $B%&%#%s%I%&%9%/%m!<%k%P!<%$%Y%s%H(B  */
void    Wscr_evn(Widget w, caddr_t client_data, caddr_t percent_ptr)
{
  float percent = *(float*)percent_ptr;
  static  int  value[4];  /*  $B%\%j%e!<%`$NCM$rF~$l$kG[Ns(B  */

  DEBUG_PRINT(("Wscr_evn()\n"));

  if(percent > 1)
      percent = 1;
  if(percent < 0)
      percent = 0;

  if(w == prgid->bbar_pid)  /*  $B:81&J}8~$N0\F0$N>l9g(B  */
  {
    value[1] = (bmpplm->org_bmp.bounds.c.right - bmpplm->org_bmp.bounds.c.left)
                                                                     * percent;
    Put_volval(0, value, bmpplm, prgid);  /*  $B%\%j%e!<%`$NCM$rH?1G$5$;$k(B  */
    Zoom(bmpplm);   /*    $B3HBg=L>.I=<((B  */
    Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  $B%&%#%s%I%&%9%/%m!<%k%P!<$N@_Dj(B  */
  }
  else if(w == prgid->rbar_pid)  /*  $B>e2<J}8~$N0\F0$N>l9g(B  */
  {
    value[0] = (bmpplm->org_bmp.bounds.c.bottom - bmpplm->org_bmp.bounds.c.top)
                                                                     * percent;
    Put_volval(1, value, bmpplm, prgid);  /*  $B%\%j%e!<%`$NCM$rH?1G$5$;$k(B  */
    Zoom(bmpplm);   /*    $B3HBg=L>.I=<((B  */
    Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  $B%&%#%s%I%&%9%/%m!<%k%P!<$N@_Dj(B  */
  }
  Rest_mask(&bmpplm->org_bmp.bounds, &bmpplm->zoom_rect, bmpplm->mask_mat,
              &bmpplm->wid_rect, &bmpplm->drw_rect, bmpplm->mask_scr,
                                                                bmpplm->zoom);
                                    /*  $B%^%9%/2hLL$+$i%^%9%/%9%/%j!<%s$X(B  */

  Harf_tone(prgid->mask_mode, bmpplm);
                /*  $B!V%^%9%/IA2h%b!<%I!W$+!V%^%9%/>C5n%b!<%I!W$N$H$-(B
                                                $B2hLL$K%O!<%U%H!<%s$r$+$1$k(B  */
}
