typedef struct size {
  short  h;
  short  v;
} SIZE;

typedef struct point {
  short  x;
  short  y;
} PNT;

typedef union rect {
  struct _rect {
    short  left;
    short  top;
    short  right;
    short  bottom;
  } c;
  struct {
    PNT  lefttop;
    PNT  righttop;
  } p;
} RECT;

typedef struct Bitmap {
  unsigned short planes;
  unsigned short pixbits;
  unsigned short rowbytes;
  RECT  bounds;             /*  Screen rect  */
  unsigned char *baseaddr;  /*  Screen data data adress  */
} BMP;

struct ColorDescripttion {
  unsigned int trans:1;  /*  $BF)L@(B  */
  unsigned int crep:3;   /*  $B%+%i!<I=8=(B  */
  unsigned int cval:28;  /*  $B%+%i!<CM(B  */
};
typedef unsigned long COLOR;  /*  $B%+%i!<;XDj(B  */

typedef int GID;  /*  $BIA2h4D6-(BID  */

typedef struct {
  short attr;   /*  $B%G%P%$%9B0@-(B  */
  short planes;   /*    */
  short pixbits;   /*    */
  short hpixels;   /*  horaiz pixels  */
  short vpixels;   /*  vert pixels  */
  short hres;   /*  $B2#$N2rA|EY(B  */
  short vres;   /*  $B=D$N2rA|EY(B  */
  short info[4];   /*  $B%+%i!<>pJs(B  */
  short resv[6];   /*    */
} DEV_SPEC;

typedef struct ColorSpec {
  int attr;        /*  $B%+%i!<B0@-(B  */
  short info[4];   /*  $B%+%i!<>pJs(B  */
  COLOR *colmap;   /*  $B%+%i!<%^%C%W$X$N%]%$%s%?(B  */
} CSPEC;  /*  $B%+%i!<;XDj(B  */

typedef int DCM;  /*  $BIA2h%b!<%I(B  */

typedef struct pattern {
    struct spat {
      int kind;              /*  $B%Q%?!<%s%?%$%W(B (=0)            */
      unsigned short hsize;   /*  $B%Q%?!<%s$N?eJ?J}8~$N%5%$%:(B  */
      unsigned short vsize;   /*  $B%Q%?!<%s$N?bD>J}8~$N%5%$%:(B  */
      COLOR    fgcol;         /*  $B%U%)%"%0%i%&%s%I$N%+%i!<(B    */
      COLOR    bgcol;         /*  $B%P%C%/%0%i%&%s%I$N%+%i!<(B    */
      unsigned char  mask;   /*  $B%Q%?!<%s%^%9%/%G!<%?$N%]%$%s%?(B  */
    } spat;
} PAT;  /*  $BIA2h%Q%?!<%s(B  */

#define    G_STORE     0x0000
#define    G_CVFORM    0x0100
#define    G_CVCOLOR   0x0200

#define    FILL100     100
#define    FILL50       50

#define L_FSNM          20
typedef struct {
  char      fs_name[L_FSNM];
  unsigned short    f_id;
  unsigned short    atr1;
  unsigned short    atr2;
  unsigned short    atr3;
  unsigned short    atr4;
  unsigned short    atr5;
} LINK;
