#include <stdlib.h>
#include <stdio.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include "xbrush.h"

extern PRGID     *prgid;          /*  $B3F<o$N#I#D(B  */
extern BMPPALA   *bmpplm;         /*  $B%S%C%H%^%C%W(B  */
extern CONSPATS  *consparts;    /*  $B%3%s%=!<%k%Q!<%D(B  */

/*  orgbuf_xim $B$H(B undo_xim $B$rF~$l49$($k(B  */
void    Chgxim_orgbuf2undo(BMPPALA *bmp_plm)
{
    XImage  *buf_xim;
    unsigned char  *buf_addr;

    DEBUG_PRINT(("Chgxim_orgbuf2undo()\n"));
    buf_xim = bmp_plm->orgbuf_xim;
    bmp_plm->orgbuf_xim = bmp_plm->undo_xim;
    bmp_plm->undo_xim = buf_xim;

    buf_addr = bmp_plm->orgbuf_bmp.baseaddr;
    bmp_plm->orgbuf_bmp.baseaddr = bmp_plm->undo_bmp.baseaddr;
    bmp_plm->undo_bmp.baseaddr = buf_addr;
}

/*  $B862hA|%P%C%U%!$K2hA|%G!<%?$r%3%T!<$9$k(B  */
void    Copy_org2orgbuf(BMPPALA *bmp_plm)
{
    int image_size;

    DEBUG_PRINT(("Copy_org2orgbuf()\n"));
    /*
    image_size = sizeof(unsigned char) * bmp_plm->org_bmp.rowbytes *
      (bmp_plm->org_bmp.bounds.c.bottom - bmp_plm->org_bmp.bounds.c.top);

    memcpy( bmp_plm->orgbuf_bmp.baseaddr, bmp_plm->org_bmp.baseaddr,
                     image_size);
    */

  if( bmp_plm->org_xim->width !=  bmp_plm->orgbuf_xim->width ||
                bmp_plm->org_xim->height !=  bmp_plm->orgbuf_xim->height )
  {
    Free_bitmap(bmp_plm->orgbuf_xim);/*  $B862hA|%P%C%U%!$N%a%b%j$r3+J|(B  */
					/*  orgbmp_bmp $B$N=i4|2=(B  */
    if(Creat_bmp(&bmp_plm->orgbuf_bmp, bmp_plm->org_bmp.bounds,
                           bmp_plm->org_bmp.planes,  bmp_plm->pixbits)     < 0)
                               /*    $B862hA|%P%C%U%!MQ$N%S%C%H%^%C%W$r:n@.(B    */
      Exit_prg(prgid, bmp_plm, consparts);

    /*  orgbuf_xim $B$N(B XImage $B4D6-$r:n$k(B  */
    bmp_plm->orgbuf_xim = CreateXImage( bmp_plm->disp,
      bmp_plm->orgbuf_bmp.bounds.c.right - bmp_plm->orgbuf_bmp.bounds.c.left,
      bmp_plm->orgbuf_bmp.bounds.c.bottom - bmp_plm->orgbuf_bmp.bounds.c.top );
                                              /*  XImage$B$N:n@.(B  */
  }

  Gcop_bmp(bmp_plm->org_xim, &(bmp_plm->org_bmp.bounds),
                    bmp_plm->orgbuf_xim, &(bmp_plm->org_bmp.bounds), NULL, 0);
 		                    /*  $B862hA|$+$i862hA|%P%C%U%!$X%3%T!<(B  */
}

/*  $B%"%s%I%%%P%C%U%!$K2hA|%G!<%?$r%3%T!<$9$k(B  */
void    Copy_undo_bmp(BMPPALA *bmp_plm)
{
  //DCM   mode = G_STORE;  /*  $BIA2h%b!<%I(B  */

  DEBUG_PRINT(("Copy_undo_bmp()\n"));

  if( bmp_plm->org_xim->width !=  bmp_plm->undo_xim->width ||
                bmp_plm->org_xim->height !=  bmp_plm->undo_xim->height )
  {
    Free_bitmap(bmp_plm->undo_xim); /*  $B%"%s%I%%%S%C%H%^%C%W$N%a%b%j$r3+J|(B  */
					/*  undo_bmp $B$N=i4|2=(B  */
    if(Creat_bmp(&bmp_plm->undo_bmp, bmp_plm->org_bmp.bounds,
                           bmp_plm->org_bmp.planes,  bmp_plm->pixbits)     < 0)
                                     /*    $B%"%s%I%%MQ$N%S%C%H%^%C%W$r:n@.(B    */
      Exit_prg(prgid, bmp_plm, consparts);

    /*  undo_xim $B$N(B XImage $B4D6-$r:n$k(B  */
    bmp_plm->undo_xim = CreateXImage( bmp_plm->disp,
          bmp_plm->undo_bmp.bounds.c.right - bmp_plm->undo_bmp.bounds.c.left,
          bmp_plm->undo_bmp.bounds.c.bottom - bmp_plm->undo_bmp.bounds.c.top );
                                              /*  XImage$B$N:n@.(B  */
  }

  Gcop_bmp(bmp_plm->org_xim, &(bmp_plm->org_bmp.bounds),
                    bmp_plm->undo_xim, &(bmp_plm->org_bmp.bounds), NULL, 0);
 		                    /*  $B862hA|$+$i%"%s%I%%%P%C%U%!$X%3%T!<(B  */
}

/*  $B%"%s%I%%(B(org_xim $B$H(B undo_xim $B$rF~$l49$($k(B)  */
void    Undo(BMPPALA *bmp_plm)
{
    XImage  *buf_xim;
    unsigned char  *buf_addr;

  DEBUG_PRINT(("Undo()\n"));

    buf_xim = bmp_plm->org_xim;
    bmp_plm->org_xim = bmp_plm->undo_xim;
    bmp_plm->undo_xim = buf_xim;

    buf_addr = bmp_plm->org_bmp.baseaddr;
    bmp_plm->org_bmp.baseaddr = bmp_plm->undo_bmp.baseaddr;
    bmp_plm->undo_bmp.baseaddr = buf_addr;

    /*Chg_xim(bmp_plm->org_xim, bmp_plm->org_bmp,
                                    bmp_plm->undo_xim, bmp_plm->undo_bmp);
                    /*  src_xim $B$H(B dst_xim $B$rF~$l49$($k(B  */

    Zoom(bmp_plm);   /*    $B3HBg=L>.(B  */
}

/*  $B%S%C%H%^%C%W$N%a%b%j$r3+J|(B  */
void    Free_bitmap(XImage *image)
{
  free(image->data);
  free(image);
}

void Key_space(Widget w, XEvent *event, String *params, int num_params)
                                                     /*  Reduce screen  */
{
  Exec_undo( NULL, NULL, NULL );
}
