/*
	xbr.c		xbrush

	XBR $B%U%!%$%k$N%;!<%V!"%m!<%I(B
*/

#include <stdlib.h>
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/Xlib.h>
#include <X11/XWDFile.h>
#include "xbrush.h"

#define  XBR_FILE_FORMAT   0x585744
#define  XBR_FILE_VERSION  1

extern PRGID     *prgid;          /*  $B3F<o$N#I#D(B  */
extern BMPPALA   *bmpplm;         /*  $B%S%C%H%^%C%W(B  */
extern CONSPATS  *consparts;    /*  $B%3%s%=!<%k%Q!<%D(B  */

typedef struct XBRHeader{  /*  XBR $B%U%)!<%^%C%H$N%X%C%@(B  */
  unsigned long  header_size;
  unsigned long  file_version;
  unsigned long  pixmap_format;
  unsigned long  pixmap_depth;
  unsigned long  pixmap_width;
  unsigned long  pixmap_height;
  unsigned long  xoffset;
  unsigned long  byte_order;
  unsigned long  bitmap_unit;
  unsigned long  bitmap_bit_order;
  unsigned long  bitmap_pad;
  unsigned long  bits_per_pixel;
  unsigned long  bytes_per_line;
  unsigned long  visual_class;
  unsigned long  red_mask;
  unsigned long  green_mask;
  unsigned long  blue_mask;
  unsigned long  bits_per_rgb;
  unsigned long  colormap_entries;
  unsigned long  ncolors;
  unsigned long  window_width;
  unsigned long  window_height;
  unsigned long  window_x;
  unsigned long  window_y;
  unsigned long  window_bdrwidth;
  unsigned long  file_format;     /*  XBR $B%U%!%$%k$N%A%'%C%/(B  */
  unsigned long  maskdataoffset;  /*  $B%^%9%/%G!<%?$X$N%*%U%;%C%H(B  */
  unsigned long  buf[20];         /*  $BM=Hw(B  */
} XBRHeader;
/*  XWD $B%U%)!<%^%C%H(B + $B%^%9%/%G!<%?$K$J$C$F$$$k(B  */
/*  XWD $B%G!<%?$K%^%9%/%G!<%?$r2C$($k$?$a$K?7$?$K(B XWD $B$r%Y!<%9$K:n$C$?(B  */

XBRHeader Ch_xbrhead( head )
XBRHeader head;
{
  head.header_size      = Ch_sb( head.header_size );
  head.file_version     = Ch_sb( head.file_version );
  head.pixmap_format    = Ch_sb( head.pixmap_format );
  head.pixmap_depth     = Ch_sb( head.pixmap_depth );
  head.pixmap_width     = Ch_sb( head.pixmap_width );
  head.pixmap_height    = Ch_sb( head.pixmap_height );
  head.xoffset          = Ch_sb( head.xoffset );
  head.byte_order       = Ch_sb( head.byte_order );
  head.bitmap_unit      = Ch_sb( head.bitmap_unit );
  head.bitmap_bit_order = Ch_sb( head.bitmap_bit_order );
  head.bitmap_pad       = Ch_sb( head.bitmap_pad );
  head.bits_per_pixel   = Ch_sb( head.bits_per_pixel );
  head.bytes_per_line   = Ch_sb( head.bytes_per_line );
  head.visual_class     = Ch_sb( head.visual_class );
  head.red_mask         = Ch_sb( head.red_mask );
  head.green_mask       = Ch_sb( head.green_mask );
  head.blue_mask        = Ch_sb( head.blue_mask );
  head.bits_per_rgb     = Ch_sb( head.bits_per_rgb );
  head.colormap_entries = Ch_sb( head.colormap_entries );
  head.ncolors          = Ch_sb( head.ncolors );
  head.window_width     = Ch_sb( head.window_width );
  head.window_height    = Ch_sb( head.window_height );
  head.window_x         = Ch_sb( head.window_x );
  head.window_y         = Ch_sb( head.window_y );
  head.window_bdrwidth  = Ch_sb( head.window_bdrwidth );
  head.file_format      = Ch_sb( head.file_format );
  head.maskdataoffset   = Ch_sb( head.maskdataoffset );
  return( head );
}

/*  XBR $B%U%!%$%k$NFI$_9~$_(B  */
int LoadXbr(Display *dsp, Visual *vis, FILE *fp, XImage *ximage,
	       BMPPALA *bmp_plm, SIZE *size, int flg)
{
  XBRHeader  head;
  XColor         xcolor[256];
  long  buf_adr, org_adr;
  int i, j, k, x, y, datasize, readflg;
  int scr, planes, depth, xwd_pixel_byte, pixel_byte;
  unsigned char title[40];
  char *buffer;

  scr      = DefaultScreen(dsp);    /*  $B%G%U%)%k%H%9%/%j!<%sHV9f(B  */
  planes   = DisplayPlanes(dsp, scr); /*  $B%G%#%9%W%l%$$N%W%l!<%s?t(B  */
  depth    = DefaultDepth(dsp, 0);

  readflg = fread( &head, sizeof(XBRHeader), 1, fp );

  if( head.file_version != 1 )   /*  Check XBR data or not  */
  {
    head = Ch_xbrhead( head );

    if( head.file_version != 1 )
    {
      return(0);
    }
  }

  if( head.file_format != XBR_FILE_FORMAT )   /*  Check XBR data or not  */
  {
    return(0);
  }

  Clr_xim(bmp_plm->canv_xim);  /* Clear main XImage */

  readflg = fread( title, head.header_size - 188, 1, fp );
  for( i = 0; i < head.ncolors; i++ )
    readflg = fread( &xcolor[i], sizeof(XColor), 1, fp );
  datasize = head.bytes_per_line * head.window_height;

  xwd_pixel_byte = head.bits_per_pixel / 8;  /* Get pixel bits of filedata */
  pixel_byte = ximage->bits_per_pixel / 8;;  /* Get pixel bits of XImage */
  //  pixel_byte = head.bits_per_pixel / 8;  /* Get pixel bits of filedata */
  //canv_pixel_byte = bmp_plm->org_xim->bits_per_pixel / 8;
                                         /* Get pixel bits of XImage */
  if( pixel_byte != 3 && pixel_byte != 4 )
  {
    fprintf( stderr, "Cannnot use %lu depth\n", head.bits_per_pixel );
    return(0);
  }

  size->h = head.window_width; size->v = head.window_height;

  if( flg == 0 )
    return(1);  /* flg $B$,(B 0 $B$N>l9g$O!"2hA|$NBg$-$5$@$1$r<h$k(B  */

  Make_mask_mat(bmp_plm);       /*  $B%^%9%/2hLLMQ%a%b%j$r:n@.(B  */

  for( j = 0; j < head.window_height; j ++ )
  {
    buffer = (char *)malloc( head.bytes_per_line );
    readflg = fread( buffer, 1, head.bytes_per_line, fp );
    for( k = 0; k < head.window_width; k ++ )
    {
      org_adr = j * ximage->bytes_per_line + k * pixel_byte;
      buf_adr = k * xwd_pixel_byte;
      if( head.byte_order != ximage->byte_order )
      {
	memcpy( ximage->data + org_adr    , buffer + buf_adr + 2, 1 );
	memcpy( ximage->data + org_adr + 1, buffer + buf_adr + 1, 1 );
	memcpy( ximage->data + org_adr + 2, buffer + buf_adr    , 1 );
      }
      else
      {
	if( pixel_byte < xwd_pixel_byte )
	  memcpy( ximage->data + org_adr, buffer + buf_adr, pixel_byte );
	else
	  memcpy( ximage->data + org_adr, buffer + buf_adr, pixel_byte );
      }
    }
    free( buffer );
  }

  fseek(fp, head.maskdataoffset, 0);  /*  $B%^%9%/%G!<%?$^$G$N%*%U%;%C%H(B  */
  readflg = fread( bmp_plm->mask_mat, 1,
                        (head.window_width * head.window_height), fp );
                                            /*  $B%^%9%/%G!<%?$r<h$j9~$`(B  */

  ximage->xoffset          =  head.xoffset;
  /*  ximage->byte_order       =  head.byte_order;*/
  ximage->bitmap_unit      =  head.bitmap_unit;
  ximage->bitmap_bit_order =  head.bitmap_bit_order;
  ximage->bitmap_pad       =  head.bitmap_pad;
  ximage->red_mask         =  head.red_mask;
  ximage->green_mask       =  head.green_mask;
  ximage->blue_mask        =  head.blue_mask;

  return(1);
}

/*  XBR $B%U%!%$%k$N=q$-9~$_(B  */
void SaveXbr(Display *dsp, Visual *vis, char *listfile,  XImage *ximage,
         BMPPALA *bmp_plm, int x, int y, float qual_el, int width, int height)
{
  XBRHeader  head;
  XColor         xcolor;
  Colormap       cmap;
  FILE *fp;
  long  buf_adr, org_adr;
  int i, j, pixel_byte;
  char *buffer;

  pixel_byte = ximage->bits_per_pixel / 8;
                                         /* Get pixel bits of XImage */

  head.header_size      = (CARD32) sizeof(head);
  head.file_version     = (CARD32) XBR_FILE_VERSION;
  head.pixmap_format    = (CARD32) ximage->format;
  head.pixmap_depth     = (CARD32) ximage->depth;
  head.pixmap_width     = (CARD32) width;
  head.pixmap_height    = (CARD32) height;
  head.xoffset          = (CARD32) ximage->xoffset;
  head.byte_order       = (CARD32) MSBFirst;
  //head.byte_order       = (CARD32) ximage->byte_order;
  head.bitmap_unit      = (CARD32) ximage->bitmap_unit;
  head.bitmap_bit_order = (CARD32) MSBFirst;
  //head.bitmap_bit_order = (CARD32) ximage->bitmap_bit_order;
  head.bitmap_pad       = (CARD32) ximage->bitmap_pad;
  head.bits_per_pixel   = (CARD32) ximage->bits_per_pixel;
  head.bytes_per_line   = (CARD32) width * head.bits_per_pixel / 8;
  head.visual_class     = (CARD32) vis->class;
  head.red_mask         = (CARD32) vis->red_mask;
  head.green_mask       = (CARD32) vis->green_mask;
  head.blue_mask        = (CARD32) vis->blue_mask;
  head.bits_per_rgb     = (CARD32) vis->bits_per_rgb;
  head.colormap_entries = (CARD32) vis->map_entries;
  head.ncolors          = (CARD32) vis->map_entries;
  head.window_width     = (CARD32) width;
  head.window_height    = (CARD32) height;
  head.window_x         = (CARD32) 0;
  head.window_y         = (CARD32) 0;
  head.window_bdrwidth  = (CARD32) 0;
  head.file_format      = (CARD32) XBR_FILE_FORMAT;
  head.maskdataoffset   = (CARD32) sizeof(head)
          + head.ncolors * sizeof(xcolor) + head.bytes_per_line * height;

  cmap = DefaultColormap( dsp, 0 );

  if( (fp = fopen( listfile, "wb" )) == NULL )
  {
    fprintf( stderr, "Cannot Open %s \n", listfile );
    return;
  }

  if( fwrite( &head, sizeof(head), 1, fp ) != 1 )
    fprintf( stderr, "Write error %s (for file header)\n", listfile );

  for( i = 0; i < head.ncolors; i++ )
  {
    xcolor.pixel = i << 16 | i << 8 | i;
    xcolor.pad   = 0;
    xcolor.flags = DoRed | DoGreen | DoBlue;
    XQueryColor( dsp, cmap, &xcolor );
    if( fwrite( &xcolor, sizeof(xcolor), 1, fp ) != 1 )
      fprintf( stderr, "Write error %s (for size of xcolor)\n", listfile );
  }

  buffer = (char *)malloc( head.bytes_per_line );

  for( i = 0; i < height; i ++ )
  {
    for( j = 0; j < width; j ++ )
    {
      org_adr = i * ximage->bytes_per_line + j * pixel_byte;
      buf_adr = j * pixel_byte;
      if( ximage->byte_order != MSBFirst )
      {
        memcpy( buffer + buf_adr + 2, ximage->data + org_adr    , 1 );
        memcpy( buffer + buf_adr + 1, ximage->data + org_adr + 1, 1 );
        memcpy( buffer + buf_adr    , ximage->data + org_adr + 2, 1 );
      }
      else
      {
        memcpy( buffer + buf_adr, ximage->data + org_adr, 3 );
      }
    }
    fwrite( buffer, head.bytes_per_line, 1, fp );
  }

  fwrite( bmp_plm->mask_mat, (head.window_width * head.window_height), 1, fp );
                                        /*  $B%^%9%/%G!<%?$N=q$-9~$_(B  */
  fclose( fp );

}
