#include <X11/extensions/XInput.h>
#include "typedef.h"

#define    PX          200
#define    PY          100
#define    PX1         150
#define    PY1         150
#define    W_WIDTH     650
#define    W_HEIGHT    600
#define    C_WIDTH     110
#define    C_HEIGHT    600
                                  /*  $B%+%i!<;XDj(B  */
#define    WHITE      0x00FFFFFF  /*  $B@dBP%+%i!<#R#G#B;XDj(B $BGr(B  */
#define    GRAY       0x00C0C0C0  /*  $B@dBP%+%i!<#R#G#B;XDj(B $B3%(B  */
#define    BLACK      0x00000000  /*  $B@dBP%+%i!<#R#G#B;XDj(B $B9u(B  */
#define    TRANS      0x80000000  /*  $BF)L@(B  */
#define    LGRAY      0x00D0D0D0  /*  $B@dBP%+%i!<#R#G#B;XDj(B $B3%(B  */
#define    DGRAY      0x00A0A0A0  /*  $B@dBP%+%i!<#R#G#B;XDj(B $B3%(B  */

#define    NOB         10      /*  $B%\%j%e!<%`$N%N%V$NBg$-$5(B  */
#define    M_MENUARTI  9       /*  $B%a%$%s%a%K%e!<$N9`L\?t(B  */
#define    F_MENUARTI  4       /*  $B4X?t%a%K%e!<$N9`L\?t(B  */
#define    MAX_BR_SIZE 180     /*  $B%V%i%7$N:GBg$NBg$-$5(B  */

#define    EXTID       0x4010  /*  $B3HD%>pJs$N%?%$%W(B  */
#define    MASK_EXTID  690     /*  $B%^%9%/#I#D(B  */

#define LENGTH   100
#define C_LENG   138
#define END      100
#define C_END    138

#ifdef	DEBUG  /*  $B%G%P%C%0%b!<%I(B  */
#define DEBUG_PRINT(arg)\
(  \
  printf("%s(#%d): ", __FILE__, __LINE__),  \
  printf arg  \
)
#else
#define	DEBUG_PRINT(arg)
#endif

typedef struct Filesel{
    Widget    box;            /*  $B%U%!%$%kA*Br%\%C%/%9(B  */
    Widget    dirview;        /*  $B%I%i%$%VI=<(MQ(B  */
    Widget    fileview;       /*  $B%U%!%$%kI=<(MQ(B  */
    Widget    filelist;       /*  $B%U%!%$%k%j%9%HMQ(B  */
    Widget    form_sel_box;   /*  $B%U%)!<%^%C%HA*Br%\%C%/%9(B  */
    Widget    format_list;    /*  $B%U%)!<%^%C%HA*Br%j%9%H(B  */
    Widget    quality;        /*  $B05=L%l%Y%k(B  */
    Widget    qual_scr;       /*  $B05=L%l%Y%k%9%/%m!<%k(B  */
} FILESEL;            /*  $B%U%!%$%kA*Br%Q%M%kMQ(B  */

typedef struct Automsk{
    Widget    main_pnl;       /*  $B%a%$%s%Q%M%k(B  */
    Widget    magn_siz;       /*  $BG\N((B  */
    Widget    undr_siz;       /*  $B2<8B(B  */
    Widget    over_siz;       /*  $B>e8B(B  */
} AUTOMSK;            /*  $B%*!<%H%^%9%/%Q%M%kMQ(B  */

typedef struct Tabpnl{
    Widget    main_pnl;       /*  $B%a%$%s%Q%M%k(B  */
    Widget    dev_lst;        /*  $B%G%P%$%9%j%9%H(B  */
    Widget    undr_siz;       /*  $BB-@Z$jCM(B  */
    Widget    scroll;         /*  $B%9%/%m!<%k%P!<(B  */
    Widget    magn_siz;       /*  $BG\N((B  */
    Widget    cansel;         /*  $B%-%c%s%;%k(B  */
    Widget    okbt;           /*  OK  */
    int       under;          /*  $BB-@Z$jCM(B  */
    int       mangn;          /*  $BG\N((B  */
} TABPNL;            /*  $B%?%V%l%C%H@_Dj%Q%M%kMQ(B  */

typedef struct Menusel{
    Pixel     fore, back;     /*  $B%&%#%8%C%H$N%+%i!<(B  */
    Widget    main_mid;       /*  $B%a%$%s%a%K%e!<(B  */
    Widget    edit_mid;       /*  $BJT=8%a%K%e!<(B  */
    Widget    mask_mid;       /*  $B%^%9%/%a%K%e!<(B  */
    Widget    expredu_mid;    /*  $B3HBg!?=L>.%a%K%e!<(B  */
    Widget    inst_mid;       /*  $B@_Dj%a%K%e!<(B  */
} MENUSEL;            /*  $B%a%K%e!<I=<(MQ(B  */

typedef struct Prg_id{
    XtAppContext app_context;
    XDevice   *xidev;      /*  XInput$B$N%G%P%$%9(B  */
    Widget    pwid;          /*  $B?F%&%#%s%I%&#I#D(B  */
    Widget    cpwid;         /*  $B?FIA2h%&%#%s%I%&#I#D(B  */
    Widget    canv_wid;      /*  $BIA2h%&%#%s%I%&#I#D(B  */
    Widget    cons_wid;      /*  $B%3%s%=!<%k%&%#%s%I%&#I#D(B  */
    Widget    main_mid;      /*  $B%3%s%=!<%k%a%$%s%a%K%e!<#I#D(B  */
    Widget    func_mid;      /*  $B%3%s%=!<%k4X?tA*Br%a%K%e!<#I#D(B  */
    Widget    vid;           /*  $B2>?H#I#D(B  */
    Widget    pict;          /*  $B%T%/%H%0%i%`$N%G!<%?HV9f(B  */
    FILESEL   filesel;       /*  $B%U%!%$%kA*Br%Q%M%kMQ(B  */
    AUTOMSK   automsk;       /*  $B%*!<%H%^%9%/%Q%M%kMQ(B  */
    MENUSEL   menusel;       /*  $B%a%K%e!<I=<(MQ(B  */
    TABPNL    tabpnl;        /*  $B%?%V%l%C%H@_Dj%Q%M%kMQ(B  */
    LINK      link;          /*  $B<B?H$X$N%j%s%/(B  */
    int      imag_no;       /*  $B<g%l%3!<%I$NCf$G2?HVL\$N2hA|$rJT=8$7$F$$$k$+(B */
    unsigned short xb_mode;       /*  $B%b!<%I(B
                            $BNN0hA*Br%b!<%I(B        0x0000 $B!?(B $BIA2h%b!<%I(B  0x0001
                            $B2hA|%;%0%a%s%H(B        0x0002$B!'M-(B
                            $B<g%l%3!<%I(B            0x0004$B!'M-(B
                            $B?7$?$KIA2h$7$?(B        0x0008$B!'%;!<%VMQ(B
                            $B%?%V%l%C%H%I%i%$%P(B    0x0010$B!';H$($k(B
                            $B%"%s%I%%%m%C%/(B        0x0020$B!'%m%C%/(B
                            $BI.05$N1F6A(B            0x0040$B!'G;EY4p=`(B
                                                  0x0080$B!'B@$54p=`(B  */
    unsigned short mmx_flg;       /*  MMX$BMQ(B  */
    unsigned short mask_mode;     /*  $B%^%9%/%b!<%I(B
                            $B%^%9%/$rIA2h$7$?(B      0x0001$B!'%;!<%VMQ(B

                            $B%^%9%/$N$_I=<(%b!<%I(B  0x0020
                            $B%^%9%/H?1GIA2h%b!<%I(B  0x0040
                            $B%^%9%/IA2h%b!<%I(B      0x0080
                            $B%^%9%/>C5n%b!<%I(B      0x00C0                     */
    unsigned short mask_sw;  /*  $B%^%9%/$,2hA|%;%0%a%s%H$K85!9$"$C$?$+$I$&$+(B  */
    Widget   rbar_pid;      /*  $B%&%#%s%I%&$N1&%9%/%m!<%k%Q!<%D#I#D(B  */
    Widget   bbar_pid;      /*  $B%&%#%s%I%&$N2<%9%/%m!<%k%Q!<%D#I#D(B  */
    int      pid;           /*  $B%W%m%;%9#I#D(B  */
    Atom     at1, at2;      /*  $B%a%C%;!<%8EAC#MQ%"%H%`(B  */
} PRGID;        /*  $B3F<o$N#I#D(B  */

typedef struct Bmppala{
    Display  *disp;        /*  $B%G%#%9%W%l%$@\B3(B  */
    GC       canv_gc;      /*  $B:n6H2hLL$N%0%i%U%#%C%/%3%s%F%-%9%H(B  */
    GC       cons_gc;      /*  $BA`:n2hLL$N%0%i%U%#%C%/%3%s%F%-%9%H(B  */
    XImage   *org_xim;     /*  SHM$BMQ(B XImage $B9=B$BN(B  ($B862h(B)*/
    XImage   *orgbuf_xim;  /*  SHM$BMQ(B XImage $B9=B$BN(B  ($B862h(Bbuf)*/
    XImage   *imag_xim;    /*  SHM$BMQ(B XImage $B9=B$BN(B  ($B:n6H2hLL(B)*/
    XImage   *canv_xim;    /*  SHM$BMQ(B XImage $B9=B$BN(B  ($BI=<(2hLL(B)*/
    XImage   *ibuf_xim;    /*  SHM$BMQ(B XImage $B9=B$BN(B  */
    XImage   *undo_xim;    /*  SHM$BMQ(B XImage $B9=B$BN(B  ($B%"%s%I%%(B)*/
    XImage   *undolock_xim;/*  $B%"%s%I%%%m%C%/$7$?$H$-$N%"%s%I%%IA2h4D6-#I#D(B  */
    int      zoom;         /*  $B3HBgN((B  */
    int      b_size;       /*  $B%V%i%7$NBg$-$5(B  */
    SIZE     org_size;     /*  $B862hA|$NBg$-$5(B  */
    SIZE     imag_size;    /*  $B:n6H2hA|$NBg$-$5(B  */
    SIZE     wid_size;     /*  $BIA2h%&%#%s%I%&$NBg$-$5(B  */
    RECT     wid_rect;     /*  $BIA2h%&%#%s%I%&$N0LCV(B  */
    RECT     cons_rect;    /*  $B%3%s%=!<%k%&%#%s%I%&$N0LCV(B  */
    RECT     zoom_rect;    /*  $B8=:_I=<($7$F$$$kJ,$N<B:]$N2hA|$NNN0h(B  */
    RECT     drw_rect;     /*  $B8=:_I=<($7$F$$$kJ,$N2hLL$N2hA|$NNN0h(B  */
    BMP      org_bmp;      /*  $B862hA|$N%S%C%H%^%C%W(B  */
    BMP      orgbuf_bmp;   /*  $B862hA|%P%C%U%!$N%S%C%H%^%C%W(B  */
    BMP      imag_bmp;     /*  $B:n6H2hA|$N%S%C%H%^%C%W(B  */
    BMP      ibuf_bmp;     /*  $B%I%i%C%0Cf0l;~3JG<MQ(B  */
    BMP      undo_bmp;     /*  $B%"%s%I%%MQ$N%S%C%H%^%C%W(B  */
    Pixmap   org_gid;      /*  $B862hA|$NIA2h4D6-#I#D(B  */
    Pixmap   imag_gid;     /*  $B:n6H2hA|$NIA2h4D6-#I#D(B  */
    Window   canv_gid;     /*  $BI=<(2hLL$NIA2h4D6-#I#D(B  */
    Pixmap   ibuf_gid;     /*  $B%I%i%C%0Cf0l;~3JG<MQIA2h4D6-#I#D(B  */
    Pixmap   drag_gid;     /*  $B%I%i%C%0MQ$NIA2h4D6-#I#D(B  */
    Pixmap   undo_gid;     /*  $B%"%s%I%%MQ$NIA2h4D6-#I#D(B  */
    Window   cons_gid;     /*  $B%3%s%=!<%kIA2h4D6-#I#D(B  */
    Pixmap   undolock_gid; /*  $B%"%s%I%%%m%C%/$7$?$H$-$N%"%s%I%%IA2h4D6-#I#D(B  */
    unsigned char *brush_scr;   /*  $B2hLL$N%V%i%7G;EY(B  */
    unsigned int  *rgbcolor_scr;  /*  $B:n6H2hA|$N#R#G#BCM$r=q$-9~$`%a%b%jNN0h(B  */
    unsigned char *mask_mat; /*  $B%^%9%/2hLL(B($B862hA|$KBP$9$k%^%9%/(B)  */
    unsigned char *mask_scr; /*  $B%^%9%/%9%/%j!<%s(B($B%&%#%s%I%&$KBP$9$k%^%9%/(B)  */
    DCM    mode;         /*  $BIA2h%b!<%I(B  */
    Font   fnt;          /*  $B%U%)%s%H;XDj(B  */
    short  pixbits;      /*  $B%T%/%;%k%S%C%H?t(B($B6-3&(B/$BM-8z(B)  */
    Colormap  imag_csp;     /*  $B2hA|$N%+%i!<>pJs(B  */
    Colormap  canv_csp;     /*  $B%&%#%s%I%&$N%+%i!<>pJs(B  */
    unsigned long   src_col;      /*  $BA*Br?'(B  */
    int       presser;      /*  $BI.05(B  */
} BMPPALA;        /*  $B%S%C%H%^%C%W$N%Q%i%a!<%?(B  */

typedef struct Pointpnt{
    Widget numx_pid;      /*  $B?tCM%\%C%/%9$N#x:BI8%Q!<%D#I#D(B  */
    RECT   numx_rect;     /*  $B?tCM%\%C%/%9$N#x:BI8I=<(0LCV(B  */
    Widget numy_pid;      /*  $B?tCM%\%C%/%9$N#y:BI8%Q!<%D#I#D(B  */
    RECT   numy_rect;     /*  $B?tCM%\%C%/%9$N#y:BI8I=<(0LCV(B  */
} POINTPNT;

typedef struct Numpart{
    Widget num_pid;      /*  $B?tCM%\%C%/%9$N%Q!<%D#I#D(B  */
    RECT   num_rect;     /*  $B?tCM%\%C%/%9$NI=<(0LCV(B  */
} NUMPART;

typedef struct Swpart{
    Widget sw_pid;      /*  $B%F%-%9%H%9%$%C%A$N%Q!<%D#I#D(B  */
    RECT   sw_rect;     /*  $B%F%-%9%H%9%$%C%A$NI=<(0LCV(B  */
} SWPART;

typedef struct Funcval{
    int    func_no;      /*  $B4X?t$NA*BrHV9f(B  */
    RECT   func_rect;    /*  $B4X?t$NI=<(0LCV(B  */
    RECT   xaxi;         /*  x$B<4$N0LCV(B  */
    RECT   yaxi;         /*  y$B<4$N0LCV(B  */
    int    r_size;       /*  $B%V%i%7$NH>7B(B  */
    int    g_size;       /*  $B%V%i%7$N:GBg$NBg$-$5!]H>7B(B  */
    unsigned char *brush_map[257];  /*  $B%V%i%7%^%C%W(B (181*181) */
} FUNCVAL;       /*  $B4X?tI=<(MQ$N%Q%i%a!<%?(B  */

typedef struct Volparam{
    Widget num_pid;         /*  $B?tCM%\%C%/%9$N%Q!<%D#I#D(B  */
    RECT   num_rect;        /*  $B?tCM%\%C%/%9$NI=<(0LCV(B  */
    int    size;            /*  $BBg$-$5(B  */
    Widget vol_pid;         /*  $B%\%j%e!<%`$N%Q!<%D#I#D(B  */
    int    vol_val[4];      /*  $B%\%j%e!<%`$N@_DjCM(B  */
    RECT   vol_rect;        /*  $B%\%j%e!<%`$NI=<(0LCV(B  */
} VOLPARAM;          /*  $B%\%j%e!<%`$N%Q%i%a!<%?(B  */

typedef struct Slctcol{
    VOLPARAM  colbar[3];/*  $B%+%i!<@_DjMQ$N%\%j%e!<%`$N%Q%i%a!<%?(B  */
    unsigned long     sel_col;  /*  $BIA2h%T%/%;%kCM(B  */
    RECT      colbox;   /*  $BIA2h%T%/%;%kCM$r%+%i!<I=<($9$kNN0h(B  */
} SLCTCOL;           /*  $BIA2h%T%/%;%kCM$N%Q%i%a!<%?(B  */

typedef struct Maskpnl{
    double   mag;   /*  $B?'$NG;EY$KBP$9$k%^%9%/%l%Y%k$NG\N((B  */
    int      un;    /*  $B@Z$j>e$2$9$k?'$NG;EY(B  */
    int      ov;    /*  $BB-@Z$j$9$k?'$NG;EY(B  */
/*  unsigned char  m_rgb      0x04:$B@V(B    0x02:$BNP(B    0x01:$B@D(B  */
} MSKPNL;           /*  $B%^%9%/%Q%M%kMQ%Q%i%a!<%?(B  */

typedef struct Consparts{
    unsigned int nbox_fmt;     /*  $B?tCM%Q!<%D$NB0@-(B  */
    POINTPNT  point_pnt;    /*  $B%]%$%s%?$N0LCV(B  */
    NUMPART   zoom_num;     /*  $B3HBgG\N((B  */
    FUNCVAL   funcval;      /*  $B4X?tI=<((B  */
    SWPART    mswpart;      /*  $B%"%s%I%%%9%$%C%A(B  */
    SWPART    aswpart;      /*  $B%"%s%I%%%m%C%/%9%$%C%A(B  */
    VOLPARAM  dens_vol;     /*  $B?'$NG;$5(B  */
    VOLPARAM  size_vol;     /*  $B%V%i%7$NBg$-$5(B  */
    SLCTCOL   slct_col;     /*  $BA*Br?'(B  */
    MSKPNL    maskpnl;      /*  $B%^%9%/%Q%M%kMQ(B  */
} CONSPATS;          /*  $B%3%s%=!<%k%Q!<%D(B  */

/*    chg_exp.c    */
void Wget_wrk(Widget wid, RECT *rect);    /*  $B%&%#%s%I%&I=<(NN0h$N0LCV(B  */
void Wfnd_wnd(Widget wid, RECT *rect);    /*  $B%&%#%s%I%&I=<(NN0h$N@dBP0LCV(B  */
void Cset_val(Widget w, int size, int *value); /*  $B%Q!<%D$NCM$N@_Dj(B  */
void Gget_fra(XImage *image, RECT *rect);  /*  $B85IA2h4D6-$NNN0h$rD4$Y$k(B  */
void Gfil_rec(XImage *image, RECT rect, PAT *pat, int angle, char mode);
                                                 /*  $BI=<(2hA|$rEI$j$D$V$9(B  */
void Gcop_bmp(XImage *src_xim, RECT *src_rect, XImage *dst_xim, RECT *dst_rect,
                                                         char *mask, int mode);
                                                      /*  $B3HBg!?=L>.%3%T!<(B  */
/*  crshm.c  */
void  ExitShm(Display *dsp);  /*  SHM$B%T%C%/%9%^%C%W$N3+J|(B  */
XImage *CreateXImage(Display *dsp, int width, int height); /*  XImage$B$N:n@.(B  */

XImage *CreateShmPixmap(Pixmap *pix, BMP *bmp, Widget wid,
                                               int width, int height);
                                                /*  SHM$B%T%C%/%9%^%C%W$N:n@.(B  */
void Clr_xim(XImage *image);  /* Clear main XImage */

void Resize_xim( Widget wid, caddr_t client_data, XEvent *event );

/*    main.c    */
void    Exit_prg(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                                 /*  $B=*N;(B  */
void    Exit(Widget w, caddr_t client_data, caddr_t call_data);
                                                /*  $B=*N;(B ($B%3!<%k%P%C%/MQ(B)  */
void    Make_imagbmp(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                                /*  $B2hLL%S%C%H%^%C%W$N:n@.(B  */
void    Redraw_canv(PRGID *prg_id, BMPPALA *bmp_plm);
                                               /*  $BIA2h%&%#%s%I%&$N:FI=<((B  */

void  Cls_gid(BMPPALA *bmp_plm); /*  $B2hLL%/%j%"(B  */

void Paint_exp_proc(Widget w, caddr_t client_data, XEvent *event);
                                                /* If Canvas expose event */
void Pointer_proc(Widget w, caddr_t client_data, XEvent *event);
                                                    /* Mouse Position  */
void Caonvas_ini(Widget parent);  /* Initialize Pixmap & XImage */
void Quit_main(Widget w, XEvent *event, String *params, int num_params);
                                                           /*  Quit main  */
void Init_consdata(); /*  $B3F<o=i4|@_Dj(B  */
int main(int argc, char *argv[]);  /*  main  */


/*  initcons.C  */
void    Init_conspt(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                       /*  $B%3%s%=!<%k$N%Q!<%D$N=i4|2=(B  */

/*  console.C  */
void    Disp_consw(GC cons_gid, CONSPATS *cons_parts);
                                       /*  $B%3%s%=!<%k%&%#%s%I%&$NI=<((B  */
void    Disp_selcol(GC cons_gid, CONSPATS *cons_parts);
                                       /*  $B@_Dj?'$NI=<((B  */
void    Draw_func(GC cons_gid, CONSPATS *cons_parts);
                                       /*  $B4X?t$NI=<((B  */

/*  consevt.C  */
void    Chg_conssize(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                      /*  $B%3%s%=!<%k%&%#%s%I%&$NBg$-$5JQ99(B  */
void    Shw_color(BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                       /*  $BA*Br?'$N@_Dj(B  */
void    Console_Evt(Widget w, caddr_t client_data, caddr_t percent_ptr);
                                                           /* Set color */
void    Vol_evn(Widget wevnt, Widget pid_vol, VOLPARAM *vol_para,
  	                         BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                                   /*  $B%\%j%e!<%`%$%Y%s%H(B  */
void    Exec_undo(Widget w, Widget client_data, caddr_t call_data );
                                                             /* Exec Undo */
void    Undo_lock(Widget w, Widget client_data, caddr_t call_data);
                                                      /* Lock Undo buffer */
void    Event_console(XEvent *event, PRGID *prg_id, BMPPALA *bmp_plm,
                                                  CONSPATS *cons_parts);
                                       /*  $B%3%s%=!<%k%&%#%s%I%&%$%Y%s%H(B  */
void    Event_cons(Widget w, caddr_t client_data, XEvent *event);


/*  drwfunc.C  */
void    Drw_graph(GC cons_gid, CONSPATS *cons_parts);
                                       /*  $B4X?t%0%i%U$r%3%s%=!<%k$KIA$/(B  */
double  Brush_func(int f_no, double x);  /*  $B3F%V%i%74X?t$KBP$9$k?'$NG;$5(B  */

/*    screen.c   */
void    Chg_cspec(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts);
                         /*  $B:n6H2hA|$H%I%i%C%0Cf0l;~3JG<MQ2hA|$N:F@_Dj(B  */

void    Chg_windsize(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                        /*  $BI=<(%&%#%s%I%&$NBg$-$5JQ99(B  */

int     Creat_bmp(BMP *bmp, RECT rect, short planes, short pixbits);
                                             /*    $B%S%C%H%^%C%W$r:n@.(B    */
void    Copy_tiles(XImage *src_xim, RECT *src_rect,
		    XImage *dst_xim, RECT *dst_rect, int zoom, int mode);
                                         /*    $B862hA|$r3HBg$7$F%3%T!<$9$k(B  */

void    Show_pntposi(XEvent *wevnt, PRGID *prg_id,
		  BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                             /*  $B%]%$%s%?$N0LCV$rI=<($9$k(B  */
void    Show_zoom(BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                                 /*  $B3HBgN($rI=<($9$k(B  */
void    Putrgb(XImage *image, PNT pos, CSPEC csp,
	                                   unsigned long cv_col[]);
                                      /*  gid $B$N(B pos $B$X(B cv_col[] $B$rIA$-9~$`(B  */
unsigned long Getpixels(XImage *image, PNT pos, CSPEC csp,
			                   unsigned long cv_col[]);
                                             /*  $B3F?'$N%T%/%;%kCM$r<h$j=P$9(B  */
void    Spoit(XEvent *wevnt, PRGID *prg_id,
	       BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                                    /*  $B%9%]%$%H5!G=(B  */

void    Cpy_org2img(BMPPALA *bmp_plm);
            /*  $B862hA|$+$i:n6H2hA|$X%3%T!<$H(B,$B%V%i%7G;EY2hLL%/%j%"(B  */
void    Clr_subscreen(BMPPALA *bmp_plm);
     /*  $B%I%i%C%0Cf0l;~3JG<MQIA2h%S%C%H%^%C%W$X%3%T!<$H%V%i%7G;EY2hLL%/%j%"(B  */
void    Set_sclbar(Widget rbar_pid, Widget bbar_pid,
                                              RECT wid_rect, RECT img_rect);
                                       /*  $B%-%c%s%P%9$N%9%/%m!<%k%P!<$N@_Dj(B  */
void    Wscr_evn(Widget w, caddr_t client_data, caddr_t percent_ptr);
                                      /*  $B%&%#%s%I%&%9%/%m!<%k%P!<%$%Y%s%H(B  */

/*    filesel.c    */
void Set_string_text( Widget w, char *name );  /* Set string Widget label */
void Popup_filesel(Widget w, caddr_t client_data, caddr_t call_data);
                                                /*  Popup Filesel Widget  */
void Popdown_filesel(Widget w, caddr_t client_data, caddr_t call_data);
                                                /* Popdown Filesel Widget */
Widget Filemenu(PRGID *prg_id);  /*  $B%U%!%$%k%;%l%/%H$N%a%K%e!<:n@.(B  */

/*    file.c    */
void Loadfile(String filename, BMPPALA *bmp_plm, PRGID *prg_id);
                                                      /*  $B%U%!%$%k%m!<%I(B  */
void Loadfile_evn(Widget w, caddr_t client_data, caddr_t call_data);
                                                      /*  Load file event  */
void Popup_fileformat(Widget w, caddr_t client_data, caddr_t call_data);
                                               /*  Popup Fileformat Widget  */
void Popdown_fileformat(Widget w, caddr_t client_data, caddr_t call_data);
                                              /* Popdown Fileformat Widget */
Widget Format_popup(Widget parent, PRGID *prg_id);  /*  Select File format */

/*    menu.c    */
void Popup_funcmenu(XEvent *wevnt, PRGID *prg_id,
                    BMPPALA *bmp_plm, CONSPATS *cons_parts);
                                                   /*  $B4X?t%a%K%e!<=hM}(B  */

void Popdown_mainmenu(Widget w, caddr_t client_data, caddr_t call_data);
                                          /*  $B%a%$%s%a%K%e!<$N%]%C%W%"%C%W(B  */

Widget MenuPopup(Widget parent);      /*  Create Manu Popup Widget  */
void Popup_maskmenu(Widget w, caddr_t client_data, caddr_t call_data);
                                              /*  $B%^%9%/%a%K%e!<I=<((B  */
Widget Maskmenu(PRGID *prg_id);    /*  $B%^%9%/%a%K%e!<:n@.(B  */


/*    mask.c    */
int     Make_mask_mat(BMPPALA *bmp_plm);   /*  $B%^%9%/2hLLMQ%a%b%j$r:n@.(B  */
int     Make_mask_scr(BMPPALA *bmp_plm);   /*  $B%^%9%/%9%/%j!<%s$r:n@.(B  */
void    Free_mask_mat(BMPPALA *bmp_plm);   /*  $B%^%9%/2hLLMQ%a%b%j>C5n(B  */
void    Free_mask_scr(BMPPALA *bmp_plm);   /*  $B%^%9%/%9%/%j!<%sMQ%a%b%j>C5n(B  */
int     Drw_Paintout(XImage *image, RECT *rect);   /*  $BGr$GEI$j$D$V$9(B  */
int     Drw_Harftone(XImage *image, RECT *rect);   /*  $B%O!<%U%H!<%s(B  */
int     Harf_tone(unsigned short mask_mode, BMPPALA *bmp_plm);
                                  /*  $B%&%#%s%I%&2hLL$K%O!<%U%H!<%s$r$+$1$k(B  */

void    Rest_mask(RECT *orgr, RECT *srcr, unsigned char *src_addr,
		  RECT *widr, RECT *dstr, unsigned char *dst_addr, int zoom);
                             /*  $B%^%9%/2hLL$+$i%^%9%/%9%/%j!<%s$X(B  */
void    Save_mask(RECT *srcr, RECT *srdr, unsigned char *src_addr,
		  RECT *orgr, RECT *dstr, unsigned char *dst_addr, int zoom);
                             /*  $B%^%9%/%9%/%j!<%s$+$i%^%9%/2hLL$X(B  */

int Mask_disp(RECT *widr, RECT *imgr, XImage *image, Colormap cspec,
		                                 unsigned char *mask_addr);
                              /*    $B2hA|$KBP$7$F%^%9%/$N>uBV$rH?1G$9$k(B    */

void Put_Maskdepth(BMPPALA *bmp_plm, int dx, int dy, int adr_y,
		                                    unsigned char den);
                                         /*  $B#1%I%C%H$:$D%^%9%/$rIA2h$9$k(B  */

void Els_Maskdepth(BMPPALA *bmp_plm, int dx, int dy, int adr_y,
		                                    unsigned char den);
                                             /*  $B#1%I%C%H$:$D%^%9%/$r>C$9(B  */
void    Rev_mask(SIZE *img_size, unsigned char *mask_addr);
                                             /*    $B%^%9%/$rH?E>$9$k(B    */

/*    zoom.c    */
int     Bmp_reduce(XImage *sgid, RECT sr, XImage *dgid, RECT dr);
                 /*  $B2hA|=L>.(B    n$B!_(Bn $B8D$N%^%H%j%/%9$N%T%/%;%kCM$rJ?6Q$9$k(B  */
void    Redus_bounds(RECT *s_rect, RECT *d_rect, int zoom, int b_size,
              		     PNT sp, PNT ep, RECT imag_rect, RECT zoom_rect);
                                   /*  $BIA2h$7$?HO0O$r7W;;$5$;$F$$$k(B  */
void    Zoom(BMPPALA *bmp_plm);  /*    $B3HBg=L>.I=<((B  */

void    Zoom_point(BMPPALA *bmp_plm);
                      /*    $BI=<($9$kJ,$N<B:]$N2hA|$NNN0h$r7W;;$9$k(B    */
void    ZoomIn(Widget w, XEvent *event, String *params, int num_params);
                                                      /*  Magnify screen  */
void    ZoomOut(Widget w, XEvent *event, String *params, int num_params);
                                                       /*  Reduce screen  */
void    Imag_mov(BMPPALA *bmp_plm, int code);  /*  $BI=<(0LCV$N0\F0(B  */

/*    undo.c    */
void Chgxim_orgbuf2undo(BMPPALA *bmpplm);
                    /*   orgbuf_xim $B$H(B undo_xim $B$rF~$l49$($k(B  */

void Copy_org2orgbuf(BMPPALA *bmp_plm);
                          /*  $B862hA|%P%C%U%!$K2hA|%G!<%?$r%3%T!<$9$k(B  */

void Copy_undo_bmp(BMPPALA *bmp_plm);
                          /*  $B%"%s%I%%%P%C%U%!$K2hA|%G!<%?$r%3%T!<$9$k(B  */

void Undo(BMPPALA *bmp_plm);
             /*  $B%"%s%I%%(B(org_xim $B$H(B undo_xim $B$rF~$l49$($k(B)  */

void Free_bitmap(XImage *image);  /*  $B%S%C%H%^%C%W$N%a%b%j$r3+J|(B  */


void Save_Undobuf(char *pathname);   /*  Save Undo buffer file  */
void Key_space(Widget w, XEvent *event, String *params, int num_params);
                                                     /*  Reduce screen  */


/*  brush.c  */
void Make_brush_scr(BMPPALA *bmp_plm);      /*  $B%V%i%7%9%/%j!<%s$N:n@.(B */
void Make_rgbcolor_scr(BMPPALA *bmp_plm);   /*  RGB$B%+%i!<%9%/%j!<%s$N:n@.(B  */
void Init_brush_map(CONSPATS *cons_parts);  /*  initiarize bursh map  */
unsigned long    Cal_color(unsigned char den, unsigned long dst_col,
			                       unsigned long src_col);
                                                  /*  $BIA2h$9$k?'$r7W;;$9$k(B */
void Set_size_el(CONSPATS *cons_parts);  /* Express brush size */
void Point_brush(BMPPALA *bmp_plm, int x, int y, CONSPATS *cons_parts,
		                                             PRGID *prg_id);
                                                  /*  $B%V%i%7$NBg$-$5J,IA2h(B  */
void Drw_brush(BMPPALA *bmp_plm, PNT sp, PNT ep,
	                                  CONSPATS *cons_parts, PRGID *prg_id);
                                                      /*  $B%I%i%C%0IA2h$N;~(B  */

void Drw_line_reng(PNT sp, PNT ep, CONSPATS *cons_parts);
                                            /*  $B%I%i%C%0Cf$NIA2hHO0O$N;XDj(B  */
/*  menu.c  */
Widget Set_menu(PRGID *prg_id, BMPPALA *bmp_plm);    /*  $B%a%K%e!<$rEPO?(B  */

/*  panel.c  */

void Init_maskpnl(MSKPNL *maskpnl);  /*  $B<+F0%^%9%/%Q%M%k$N=i4|2=(B  */

Widget  Automaskmenu(CONSPATS *cons_parts, PRGID *prg_id);
                                    /*    $B<+F0%^%9%/@_Dj%Q%M%k(B    */
int  Automask_pnl(CONSPATS *cons_parts); /*  $B<+F0%^%9%/$N%]%C%W%"%C%W(B  */
void Auto_mask(BMPPALA *bmp_plm, MSKPNL *maskpnl); 
                                            /*    $B<+F0%^%9%/5!G=(B    */
unsigned long Ch_sb( unsigned long h_data );  /*  Change LSB to MSB (or MSB to LSB)  */

/*  tabletto.C  */
int  Settabletto(BMPPALA *bmp_plm, PRGID *prg_id, char *dev);
                                /*    $B%?%V%l%C%H%I%i%$%P$,>oCs$7$F$$$k$+(B    */
int  Gettabvalue(BMPPALA *bmp_plm, PRGID *prg_id);  /*  $B8=:_$NI.05$rD4$Y$k(B  */
Widget  Tablettomenu(CONSPATS *cons_parts, PRGID *prg_id);
                                    /*  $B%?%V%l%C%H@_Dj%Q%M%k$N:n@.(B  */
int  Tabletto_pnl(CONSPATS *cons_parts, PRGID *prg_id);
                                   /*  $B%?%V%l%C%H@_Dj$N%]%C%W%"%C%W(B  */

/*  xbr.c  */
int LoadXbr(Display *dsp, Visual *vis, FILE *fp, XImage *ximage,
                      BMPPALA *bmp_plm, SIZE *size, int flg);
                                              /*  XBR $B%U%!%$%k$NFI$_9~$_(B  */
void SaveXbr(Display *dsp, Visual *vis, char *listfile,  XImage *ximage,
	BMPPALA *bmp_plm, int x, int y, float qual_el, int width, int height);
                                             /*  XBR $B%U%!%$%k$N=q$-9~$_(B  */
/*  jpeg.c  */
int LoadJpeg(Display *dsp, Visual *vis, FILE *fp, XImage *ximage,
                                           SIZE *size, int flg);
                                              /*  jpeg $B%U%!%$%k$NFI$_9~$_(B  */
void SaveJpeg(Display *dsp, Visual *vis, char *listfile,  XImage *ximage,
              int x, int y, float qual_el, int width, int height);
                                             /*  jpeg $B%U%!%$%k$N=q$-9~$_(B  */
/*  png.c  */
int LoadPng(Display *dsp, Visual *vis, FILE *fp, XImage *ximage,
                                           SIZE *size, int flg);
                                              /*  png $B%U%!%$%k$NFI$_9~$_(B  */
void SavePng(Display *dsp, Visual *vis, char *listfile,  XImage *ximage,
	     int x, int y, float qual_el, int width, int height);
                                             /*  png $B%U%!%$%k$N=q$-9~$_(B  */
/*  xwd.c  */
int LoadXwd(Display *dsp, Visual *vis, FILE *fp, XImage *ximage,
                                           SIZE *size, int flg);
                                              /*  XWD $B%U%!%$%k$NFI$_9~$_(B  */
void SaveXwd(Display *dsp, Visual *vis, char *listfile,  XImage *ximage,
	     int x, int y, float qual_el, int width, int height);
                                             /*  XWD $B%U%!%$%k$N=q$-9~$_(B  */
