/*
	xwd.c

	XWD $B%U%!%$%k$N%;!<%V!"%m!<%I(B
*/

#include <stdlib.h>
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/Xlib.h>
#include <X11/XWDFile.h>

typedef struct size {
  short  h;
  short  v;
} SIZE;

unsigned long Ch_sb( unsigned long h_data)
{                         /*  Change LSB to MSB (or MSB to LSB)  */
   unsigned long h_buf;

  h_buf = h_data >> 24;
  h_buf += ( h_data & 0x00ff0000 ) >> 8;
  h_buf += ( h_data & 0x0000ff00 ) << 8;
  h_buf += ( h_data & 0x000000ff ) << 24;

  return( h_buf );
}

XWDFileHeader Ch_head( head )
XWDFileHeader head;
{
  head.header_size      = Ch_sb( head.header_size );
  head.file_version     = Ch_sb( head.file_version );
  head.pixmap_format    = Ch_sb( head.pixmap_format );
  head.pixmap_depth     = Ch_sb( head.pixmap_depth );
  head.pixmap_width     = Ch_sb( head.pixmap_width );
  head.pixmap_height    = Ch_sb( head.pixmap_height );
  head.xoffset          = Ch_sb( head.xoffset );
  head.byte_order       = Ch_sb( head.byte_order );
  head.bitmap_unit      = Ch_sb( head.bitmap_unit );
  head.bitmap_bit_order = Ch_sb( head.bitmap_bit_order );
  head.bitmap_pad       = Ch_sb( head.bitmap_pad );
  head.bits_per_pixel   = Ch_sb( head.bits_per_pixel );
  head.bytes_per_line   = Ch_sb( head.bytes_per_line );
  head.visual_class     = Ch_sb( head.visual_class );
  head.red_mask         = Ch_sb( head.red_mask );
  head.green_mask       = Ch_sb( head.green_mask );
  head.blue_mask        = Ch_sb( head.blue_mask );
  head.bits_per_rgb     = Ch_sb( head.bits_per_rgb );
  head.colormap_entries = Ch_sb( head.colormap_entries );
  head.ncolors          = Ch_sb( head.ncolors );
  head.window_width     = Ch_sb( head.window_width );
  head.window_height    = Ch_sb( head.window_height );
  head.window_x         = Ch_sb( head.window_x );
  head.window_y         = Ch_sb( head.window_y );
  head.window_bdrwidth  = Ch_sb( head.window_bdrwidth );

  return( head );
}

/*  XWD $B%U%!%$%k$NFI$_9~$_(B  */
int LoadXwd(Display *dsp, Visual *vis, FILE *fp, XImage *ximage,
                                      SIZE *size, int flg)
{
  XWDFileHeader  head;
  XColor         xcolor[256];
  long  buf_adr, org_adr;
  int i, j, k, datasize, readflg;
  int scr, planes, depth, xwd_pixel_byte, pixel_byte;
  unsigned char title[40];
  char *buffer;
  char co[3];

  scr      = DefaultScreen(dsp);    /*  $B%G%U%)%k%H%9%/%j!<%sHV9f(B  */
  planes   = DisplayPlanes(dsp, scr); /*  $B%G%#%9%W%l%$$N%W%l!<%s?t(B  */
  depth    = DefaultDepth(dsp, 0);  /*  $B%9%/%j!<%s$N?'$N?<$5(B  */

  readflg = fread( &head, sizeof(XWDFileHeader), 1, fp );

  if( head.file_version != 7 )   /*  Check XWD data or not  */
  {
    head = Ch_head( head );
    if( head.file_version != 7 )
    {
      return(0);
    }
  }

  readflg = fread( title, head.header_size - 100, 1, fp );
  for( i = 0; i < head.ncolors; i++ )
    readflg = fread( &xcolor[i], sizeof(XColor), 1, fp );
  datasize = head.bytes_per_line * head.window_height;

  xwd_pixel_byte = head.bits_per_pixel / 8;  /* Get pixel bits of filedata */
  pixel_byte = ximage->bits_per_pixel / 8;;  /* Get pixel bits of XImage */

  /*
  if( pixel_byte != 3 && pixel_byte != 4 )
  {
    fprintf( stderr, "Cannnot use %lu depth\n", head.bits_per_pixel );
    return(0);
  }
  */

  size->h = head.window_width; size->v = head.window_height;

  if( flg == 0 )
    return(1);  /* flg $B$,(B 0 $B$N>l9g$O!"2hA|$NBg$-$5$@$1$r<h$k(B  */

  for( j = 0; j < head.window_height; j ++ )
  {
    buffer = (char *)malloc( head.bytes_per_line );
    readflg = fread( buffer, 1, head.bytes_per_line, fp );
    for( k = 0; k < head.window_width; k ++ )
    {
      org_adr = j * ximage->bytes_per_line + k * pixel_byte;
      buf_adr = k * xwd_pixel_byte;
      if( head.byte_order != ximage->byte_order )
      {
        if( depth == 16 )  /*  $B%&%#%s%I%&$,(B 16bit $B%+%i!<$N>l9g(B  */
	{
          co[0] = (*(buffer + buf_adr - 1) & 0xff) >> 3;
          co[1] = (*(buffer + buf_adr - 2) & 0xff) >> 2;
          co[2] = (*(buffer + buf_adr - 3) & 0xff) >> 3;
          *(ximage->data + org_adr     ) = co[0] | co[1] << 5;
          *(ximage->data + org_adr + 1 ) = co[1] >> 3 | co[2] << 3;
        }
	else
        {
	  memcpy( ximage->data + org_adr    , buffer + buf_adr + 2, 1 );
	  memcpy( ximage->data + org_adr + 1, buffer + buf_adr + 1, 1 );
	  memcpy( ximage->data + org_adr + 2, buffer + buf_adr    , 1 );
        }
      }
      else
      {
	if( pixel_byte < xwd_pixel_byte )
	  memcpy( ximage->data + org_adr, buffer + buf_adr, pixel_byte );
	else
	  memcpy( ximage->data + org_adr, buffer + buf_adr, xwd_pixel_byte );
        if( depth == 16 )  /*  $B%&%#%s%I%&$,(B 16bit $B%+%i!<$N>l9g(B  */
	{
          co[0] = (*(ximage->data + org_adr    ) & 0xff) >> 3;
          co[1] = (*(ximage->data + org_adr + 1) & 0xff) >> 2;
          co[2] = (*(ximage->data + org_adr + 2) & 0xff) >> 3;
          *(ximage->data + org_adr     ) = co[0] | co[1] << 5;
          *(ximage->data + org_adr + 1 ) = co[1] >> 3 | co[2] << 3;
        }
      }
    }
    free( buffer );
  }

  ximage->xoffset          =  head.xoffset;
  /*  ximage->byte_order       =  head.byte_order;*/
  ximage->bitmap_unit      =  head.bitmap_unit;
  ximage->bitmap_bit_order =  head.bitmap_bit_order;
  ximage->bitmap_pad       =  head.bitmap_pad;
  ximage->red_mask         =  head.red_mask;
  ximage->green_mask       =  head.green_mask;
  ximage->blue_mask        =  head.blue_mask;

  return(1);
}

/*  XWD $B%U%!%$%k$N=q$-9~$_(B  */
void SaveXwd(Display *dsp, Visual *vis, char *listfile,  XImage *ximage,
              int x, int y, float qual_el, int width, int height)
{
  XWDFileHeader  head, head_reb;
  XColor         xcolor;
  Colormap       cmap;
  FILE *fp;
  long  buf_adr, org_adr;
  int i, j, pixel_byte;
  char *buffer, co[3];

  pixel_byte = ximage->bits_per_pixel / 8;
                                         /* Get pixel bits of XImage */

  head.header_size      = (CARD32) sizeof(head);
  head.file_version     = (CARD32) XWD_FILE_VERSION;
  head.pixmap_format    = (CARD32) ximage->format;
  head.pixmap_depth     = (CARD32) ximage->depth;
  head.pixmap_width     = (CARD32) width;
  head.pixmap_height    = (CARD32) height;
  head.xoffset          = (CARD32) ximage->xoffset;
  head.byte_order       = (CARD32) MSBFirst;
  //head.byte_order       = (CARD32) ximage->byte_order;
  head.bitmap_unit      = (CARD32) ximage->bitmap_unit;
  head.bitmap_bit_order = (CARD32) MSBFirst;
  //head.bitmap_bit_order = (CARD32) ximage->bitmap_bit_order;
  head.bitmap_pad       = (CARD32) ximage->bitmap_pad;
  head.bits_per_pixel   = (CARD32) ximage->bits_per_pixel;
  head.bytes_per_line   = (CARD32) width * head.bits_per_pixel / 8;
  head.visual_class     = (CARD32) vis->class;
  head.red_mask         = (CARD32) vis->red_mask;
  head.green_mask       = (CARD32) vis->green_mask;
  head.blue_mask        = (CARD32) vis->blue_mask;
  head.bits_per_rgb     = (CARD32) vis->bits_per_rgb;
  head.colormap_entries = (CARD32) vis->map_entries;
  //head.ncolors          = (CARD32) vis->map_entries;
  head.ncolors          = (CARD32) 0;
  head.window_width     = (CARD32) width;
  head.window_height    = (CARD32) height;
  head.window_x         = (CARD32) 0;
  head.window_y         = (CARD32) 0;
  head.window_bdrwidth  = (CARD32) 0;

  cmap = DefaultColormap( dsp, 0 );

  if( (fp = fopen( listfile, "wb" )) == NULL )
  {
    fprintf( stderr, "Cannot Open %s \n", listfile );
    return;
  }

  head_reb = Ch_head( head );

  if( fwrite( &head_reb, sizeof(head_reb), 1, fp ) != 1 )
    fprintf( stderr, "Write error %s (for file header)\n", listfile );

  for( i = 0; i < head.ncolors; i++ )
  {
    xcolor.pixel = i << 16 | i << 8 | i;
    xcolor.pad   = 0;
    xcolor.flags = DoRed | DoGreen | DoBlue;
    XQueryColor( dsp, cmap, &xcolor );
    if( fwrite( &xcolor, sizeof(xcolor), 1, fp ) != 1 )
      fprintf( stderr, "Write error %s (for size of xcolor)\n", listfile );
  }

  buffer = (char *)malloc( head.bytes_per_line );

  /*
  DEBUG_PRINT(("head.pixmap_depth:%d  ximage->bits_per_pixel:%d\n",
                 head.pixmap_depth, ximage->bits_per_pixel));
  DEBUG_PRINT(("ximage->bytes_per_line:%d  pixel_byte:%d\n",
                    ximage->bytes_per_line, pixel_byte));
  */

  for( i = 0; i < height; i ++ )
  {
    for( j = 0; j < width; j ++ )
    {
      org_adr = i * ximage->bytes_per_line + j * pixel_byte;
      buf_adr = j * pixel_byte;
      co[0] = *(ximage->data + org_adr    ) & 0xff;
      co[1] = *(ximage->data + org_adr + 1) & 0xff;
      co[2] = *(ximage->data + org_adr + 2) & 0xff;

      if( ximage->byte_order != MSBFirst )
      {
	memcpy( buffer + buf_adr + 2, co    , 1 );
	memcpy( buffer + buf_adr + 1, co + 1, 1 );
        if( head.pixmap_depth > 16 )  /*  $B%&%#%s%I%&$,(B 24bit $B%+%i!<$N>l9g(B  */
	  memcpy( buffer + buf_adr    , co + 2, 1 );
      }
      else
      {
	memcpy( buffer + buf_adr    , co    , 1 );
	memcpy( buffer + buf_adr + 1, co + 1, 1 );
        if( head.pixmap_depth > 16 )  /*  $B%&%#%s%I%&$,(B 24bit $B%+%i!<$N>l9g(B  */
  	  memcpy( buffer + buf_adr + 2, co + 2, 1 );
      }

    }
    fwrite( buffer, head.bytes_per_line, 1, fp );
  }
  free( buffer );

  fclose( fp );

}
